#ifndef CLAARRAY_INCL
#define CLAARRAY_INCL
#ifndef __32BIT__
#include <windows.h>
#endif
/* The element, will usually be further derived */

class csl_selement {
public:
  virtual ~csl_selement() {};
};

typedef csl_selement *se_ptr;

// The base memory block is potentially 'very big' so 16bit has to be babied..
#if __32BIT__
typedef se_ptr *se_ptr_ptr;
#define MEMCPY(x,y,z) memcpy((x),(y),(z))
#define MEMMOVE(x,y,z) memmove((x),(y),(z))
#else
typedef se_ptr huge *se_ptr_ptr;
#define MEMCPY(x,y,z) hmemcpy((x),(y),(z))
// There doesn't seem to be hmemmove so chance the arm ...
#define MEMMOVE(x,y,z) hmemcpy((x),(y),(z))
#endif


class csl_exp_array
{
  private:
    BYTE size;
#pragma save,call(near_call=>on)
    void init();
    void space();
#pragma restore
  protected:
    se_ptr_ptr head;
#ifndef __32BIT__
    HGLOBAL exp_handle;
#endif
    unsigned long used;
  public:
#pragma save,call(reg_param=>(bx,es,ax,cx,dx,si,di))
    csl_exp_array();
    ~csl_exp_array();
    csl_selement &item(unsigned long pos) const;   /* Get item at pos         */
    unsigned long ordinality() const { return used; };  /* Return number of items  */
    BOOL is_item(unsigned long pos = 0) const;          /* Is there an item at pos     */
    void kill();                               /* Remove all items            */
    void clear();                              /* Remove all items - don't destruct */
    void replace(csl_selement &, unsigned long pos, BOOL nodel = 0); /* Replace an item at pos */
    void remove(unsigned long pos, BOOL nodel = 0); /* Remove (delete) item at pos */
    void append(csl_selement &);                   /* Adds to end of array        */
    void add(csl_selement &, unsigned long pos);        /* Adds at pos                 */
    void swap(unsigned long pos1, unsigned long pos2);   /* Swap the two elements       */
    void rotate(unsigned long pos1, unsigned long pos2, unsigned long number); /* pos1 pos x pos2 => pos2 pos1 pos x */
    unsigned long find(csl_selement *) const;           /* returns position, or -1     */
    BOOL zap(csl_selement *, BOOL nodel = 0);      /* delete if found             */
#pragma restore
};

#endif