#if 0
ͻ
   COPYRIGHT (C) 1990 Clarion Software, Inc. All Rights Reserved              
                                                                              
   Module:                                                                    
       clamemh                                                                
                                                                              
   Description:                                                               
                                                                              
       Contains the #defines and the typedefs used by the Clarion Memory      
       Management Library.                                                    
   History:                                                                   
                                                                              
   Date        Who Comments                                                   
   ========    === =====================                                      
   12/06/90    kak top speed                                                  
                                                                              
ͼ
#endif

#ifndef _CLAMEM_INCL
#define _CLAMEM_INCL

#ifdef __cplusplus
extern "C" {
#else
#pragma save,name(prefix=>"")
#endif

typedef int (CMPFUNC)(void *op1, void *op2, unsigned len );

typedef struct tagFLELMHDR FLELMHDR;
typedef struct tagFLQDESC  FLQDESC;

struct tagELMHDR
{
  ELMHDR   *nextl;        /* next element header pointer      */
  ELMHDR   *prevl;        /* prev element header pointer      */
  unsigned long sizel;    /* size of the element data         */
};                        /* ELeMent HeaDeR                   */

struct tagQUEUECTL
{
  ELMHDR   *curel;        /* current(last accessed) element in data que */
  unsigned  curoffs;      /* relative offset of current element into que */
  ELMHDR  **qndx;         /* pointer to index buffer if any */
  char      ndxhits;      /* count index hits/misses, for algo. sensitivity */
  unsigned  reclen;       /* length of queue record */
  char      ncomps;       /* number of components in key */
  FLDDESC   comp[16];     /* details of components that make up the key */
  int       fldmap[16];   /* crossref 'comp' flds into flddesc flds. */
  unsigned  mjrcount;     /* number elems in flddesc "major descriptors" */
#ifdef _WIN
  char      WasModified;
  unsigned long NumChanges;
#endif
  FLDDESC   flddesc[1];   /* ... first in list of all fields in queue */
};

struct tagFLELMHDR
{
  FLELMHDR *nextl;        /* next element header pointer      */
  FLELMHDR *prevl;        /* prev element header pointer      */
};                        /* Fixed Length ELeMent HeaDeR      */

struct tagFLQDESC
{
   FLELMHDR *qfront;        /* pointer to front of queue        */
   FLELMHDR *qback;         /* pointer to back of queue         */
   unsigned long qcount;    /* number of elements in the queue  */
   unsigned long qelmlen;   /* queue element length             */
};                          /* Fixed Length Queue DESCriptor    */


#define QERR    ((ELMHDR *)-1)
#define FLQERR  ((FLELMHDR *)-1)

/*==VM QUES===================================================================*/

extern  ELMHDR  **Cla$Quendx;
extern  unsigned  Cla$Quendxsize;

ELMHDR *      Cla$scanque(ELMHDR *from,ELMHDR *to, void *data,unsigned offs,unsigned len,CMPFUNC *cmpfnc);
unsigned      Cla$posque(QDESC *qdesc,ELMHDR *loc);
ELMHDR *      Cla$setque(QDESC *qdesc,unsigned *number);
ELMHDR *      Cla$setqx(QDESC *qdesc,ELMHDR *ptr,unsigned cur,unsigned);
void          Cla$cutflque(FLQDESC *qdesc,FLELMHDR *start,FLELMHDR *stop,FLQDESC *newqdesc);
void          Cla$cutque(QDESC *qdesc,ELMHDR *start,ELMHDR *stop,QDESC *newqdesc);
unsigned      Cla$deflque(FLQDESC *qdesc,void *buffer);
void          Cla$delque(QDESC *qdesc,ELMHDR *loc);
unsigned      Cla$deque(QDESC *qdesc,void *buffer);
ELMHDR *      Cla$findque(QDESC *qdesc,void *data,unsigned offs,unsigned len,CMPFUNC *cmpfnc,int *fndsw);
void          Cla$freeque(QDESC *qdesc);
unsigned      Cla$getflque(FLQDESC *qdesc,FLELMHDR *loc,void *buf,unsigned max);
unsigned      Cla$getque(QDESC *qdesc,ELMHDR *ptr,void *buf,unsigned max);
void          Cla$initflque(FLQDESC *qdesc,unsigned size);
void          Cla$initque(QDESC *qdesc);
FLELMHDR *    Cla$insflque(FLQDESC *qdesc,FLELMHDR *loc,void *data);
ELMHDR *      Cla$insque(QDESC *qdesc,ELMHDR *loc,void *data,unsigned size);
int           Cla$sortque(QDESC *qdesc, unsigned offs,unsigned len,CMPFUNC *cmpfnc);
int           Cla$sortflque(FLQDESC *qdesc, unsigned offs,unsigned len,CMPFUNC *cmpfnc);
void          Cla$mrgque(QDESC *qdesc,ELMHDR *loc,QDESC *qdescin);
FLELMHDR *    Cla$nullflque(FLQDESC *qdesc);
ELMHDR *      Cla$nullque(QDESC *qdesc,unsigned size);
ELMHDR *      Cla$nxtque(QDESC *qdesc,ELMHDR *loc);
unsigned      Cla$popflque(FLQDESC *qdesc,void *buffer,unsigned maxsize);
unsigned      Cla$popque(QDESC *qdesc,void *buffer,unsigned maxsize);
ELMHDR *      Cla$prvque(QDESC *qdesc,ELMHDR *loc);
FLELMHDR *    Cla$putflque(FLQDESC *qdesc,FLELMHDR *loc,void *buffer);
ELMHDR *      Cla$putque(QDESC *qdesc,ELMHDR *loc,void *buffer,unsigned size);
void          Cla$moveque( ELMHDR* before, ELMHDR* from );
unsigned      Cla$ndxque( QDESC *que, unsigned ndxsize, ELMHDR **ndxbuf );
ELMHDR *      Cla$setndxque( QDESC *que, unsigned pos );
void          Cla$indexque_on(QDESC *que, unsigned ndxsize, ELMHDR **ndxbuf);
void          Cla$indexque_off(QDESC *que);
unsigned      Cla$qtovm(QDESC *q, QDESC *vmq );
unsigned      Cla$vmtoq(QDESC *vmq, QDESC *q );
unsigned      Cla$flqtovm(FLQDESC *q, FLQDESC *vmq );
unsigned      Cla$vmtoflq(FLQDESC *vmq, FLQDESC *q );
unsigned      Cla$copyque(QDESC *srcq, ELMHDR* sstart, QDESC *destq, ELMHDR* dstart, unsigned count);

unsigned	  Cla$checkque(QDESC *q, ELMHDR *ele);

/*--------------------------------------------------------------------------*/

#define Cla$scanflque(from,to,data,offs,len,cmpfnc)\
                Cla$scanque((ELMHDR*)from,(ELMHDR*)to,data,offs-4,len,cmpfnc)

#define Cla$enque(a,b,c) (ELMHDR *)Cla$insque(a,(ELMHDR *)a,b,c)
#define Cla$enflque(a,b) (FLELMHDR *)Cla$insflque(a,(FLELMHDR *)a,b)

#define Cla$delflque(qdesc,loc)\
                (Cla$delque((QDESC*)qdesc,(ELMHDR*)loc))
#define Cla$findflque(qdesc,data,offs,len,cmpfnc,fndsw)\
                ((FLELMHDR *)Cla$findque((QDESC *)qdesc,data,offs-4,cmpfnc,fndsw))

#define Cla$freeflque(qdesc)\
                Cla$freeque((QDESC*)qdesc)

#define Cla$mrgflque(qdesc,loc,qdescin)\
                (Cla$mrgque((QDESC *)qdesc,(ELMHDR *)loc,(QDESC *)qdescin))
#define Cla$nxtflque(qdesc,loc)\
            ((FLELMHDR *)Cla$nxtque((QDESC *)qdesc,(ELMHDR *)loc))
#define Cla$posflque(qdesc,loc)\
                         (Cla$posque((QDESC *)qdesc,(ELMHDR *)loc))
#define Cla$prvflque(qdesc,loc)\
            ((FLELMHDR *)Cla$prvque((QDESC *)qdesc,(ELMHDR *)loc))
#define Cla$pushque(a,b,c) ((ELMHDR *)Cla$insque(a,(ELMHDR *)a,b,c))
#define Cla$pushflque(a,b) ((FLELMHDR *)Cla$insflque(a,(FLELMHDR *)a,b))

#define Cla$setflque(qdesc,ptr)\
            ((FLELMHDR *)Cla$setque((QDESC *)qdesc,(unsigned *)ptr))
#define Cla$setflqx(qdesc,ptr,curpos,newpos)\
            ((FLELMHDR *)Cla$setqx((QDESC *)qdesc,(ELMHDR *)ptr,curpos,newpos))

#define Cla$moveflque(a,b)  (moveque((ELMHDR*) a, (ELMHDR*) b))

    #define Cla$forque(a,b) for(a=(a)->nextl;a!=(ELMHDR*)b;a=(a)->nextl)
    #define Cla$forflque(a,b) for(a=(a)->nextl;a!=(FLELMHDR*)b;a=(a)->nextl)
    #define Cla$forquedir(a,b,c) for(a=(a)->c;a!=(ELMHDR*)b;a=(a)->c)
    #define Cla$forflquedir(a,b,c) for(a=(a)->c;a!=(FLELMHDR*)b;a=(a)->c)

#ifdef __cplusplus
}
#else
#pragma restore
#endif

#endif  // _CLAMEM_INCL
