enum keycode
{
None             = 0,
Key0             = 0x0030,
Key1             = 0x0031,
Key2             = 0x0032,
Key3             = 0x0033,
Key4             = 0x0034,
Key5             = 0x0035,
Key6             = 0x0036,
Key7             = 0x0037,
Key8             = 0x0038,
Key9             = 0x0039,

AKey             = 0x0041,
BKey             = 0x0042,
CKey             = 0x0043,
DKey             = 0x0044,
EKey             = 0x0045,
FKey             = 0x0046,
GKey             = 0x0047,
HKey             = 0x0048,
IKey             = 0x0049,
JKey             = 0x004A,
KKey             = 0x004B,
LKey             = 0x004C,
MKey             = 0x004D,
NKey             = 0x004E,
OKey             = 0x004F,
PKey             = 0x0050,
QKey             = 0x0051,
RKey             = 0x0052,
SKey             = 0x0053,
TKey             = 0x0054,
UKey             = 0x0055,
VKey             = 0x0056,
WKey             = 0x0057,
XKey             = 0x0058,
YKey             = 0x0059,
ZKey             = 0x005A,

F1Key            = 0x0070,
F2Key            = 0x0071,
F3Key            = 0x0072,
F4Key            = 0x0073,
F5Key            = 0x0074,
F6Key            = 0x0075,
F7Key            = 0x0076,
F8Key            = 0x0077,
F9Key            = 0x0078,
F10Key           = 0x0079,
F11Key           = 0x007A,
F12Key           = 0x007B,

AstKey           = 0x006A,
BSKey            = 0x0008,
CapsLockKey      = 0x0014,
DecimalKey       = 0x006E,
DeleteKey        = 0x002E,
DownKey          = 0x0028,
EndKey           = 0x0023,
EnterKey         = 0x000D,
EscKey           = 0x001B,
HomeKey          = 0x0024,
InsertKey        = 0x002D,
LeftKey          = 0x0025,
MinusKey         = 0x006D,
PauseKey         = 0x0013,
PgDnKey          = 0x0022,
PgUpKey          = 0x0021,
PlusKey          = 0x006B,
PrintKey         = 0x002C,
RightKey         = 0x0027,
SlashKey         = 0x006F,
SpaceKey         = 0x0020,
TabKey           = 0x0009,
UpKey            = 0x0026,

KeyPad0          = 0x0060,
KeyPad1          = 0x0061,
KeyPad2          = 0x0062,
KeyPad3          = 0x0063,
KeyPad4          = 0x0064,
KeyPad5          = 0x0065,
KeyPad6          = 0x0066,
KeyPad7          = 0x0067,
KeyPad8          = 0x0068,
KeyPad9          = 0x0069,

MouseLeft        = 0x0001,
MouseRight       = 0x0002,
MouseCenter      = 0x0003,
MouseLeft2       = 0x0005,
MouseRight2      = 0x0006,
MouseCenter2     = 0x0007,

Alt0             = 0x0430,
Alt1             = 0x0431,
Alt2             = 0x0432,
Alt3             = 0x0433,
Alt4             = 0x0434,
Alt5             = 0x0435,
Alt6             = 0x0436,
Alt7             = 0x0437,
Alt8             = 0x0438,
Alt9             = 0x0439,

AltA             = 0x0441,
AltB             = 0x0442,
AltC             = 0x0443,
AltD             = 0x0444,
AltE             = 0x0445,
AltF             = 0x0446,
AltG             = 0x0447,
AltH             = 0x0448,
AltI             = 0x0449,
AltJ             = 0x044A,
AltK             = 0x044B,
AltL             = 0x044C,
AltM             = 0x044D,
AltN             = 0x044E,
AltO             = 0x044F,
AltP             = 0x0450,
AltQ             = 0x0451,
AltR             = 0x0452,
AltS             = 0x0453,
AltT             = 0x0454,
AltU             = 0x0455,
AltV             = 0x0456,
AltW             = 0x0457,
AltX             = 0x0458,
AltY             = 0x0459,
AltZ             = 0x045A,

AltF1            = 0x0470,
AltF2            = 0x0471,
AltF3            = 0x0472,
AltF4            = 0x0473,
AltF5            = 0x0474,
AltF6            = 0x0475,
AltF7            = 0x0476,
AltF8            = 0x0477,
AltF9            = 0x0478,
AltF10           = 0x0479,
AltF11           = 0x047A,
AltF12           = 0x047B,

AltAst           = 0x046A,
AltBS            = 0x0408,
AltDecimal       = 0x046E,
AltDelete        = 0x042E,
AltDown          = 0x0428,
AltEnd           = 0x0423,
AltEnter         = 0x040D,
AltEsc           = 0x041B,
AltHome          = 0x0424,
AltInsert        = 0x042D,
AltLeft          = 0x0425,
AltMinus         = 0x046D,
AltPause         = 0x0413,
AltPgDn          = 0x0422,
AltPgUp          = 0x0421,
AltPlus          = 0x046B,
AltPrint         = 0x042C,
AltRight         = 0x0427,
AltSlash         = 0x046F,
AltSpace         = 0x0420,
AltTab           = 0x0409,
AltUp            = 0x0426,

AltPad0          = 0x0460,
AltPad1          = 0x0461,
AltPad2          = 0x0462,
AltPad3          = 0x0463,
AltPad4          = 0x0464,
AltPad5          = 0x0465,
AltPad6          = 0x0466,
AltPad7          = 0x0467,
AltPad8          = 0x0468,
AltPad9          = 0x0469,

AltMouseLeft     = 0x0401,
AltMouseRight    = 0x0402,
AltMouseCenter   = 0x0403,
AltMouseLeft2    = 0x0405,
AltMouseRight2   = 0x0406,
AltMouseCenter2  = 0x0407,

Ctrl0            = 0x0230,
Ctrl1            = 0x0231,
Ctrl2            = 0x0232,
Ctrl3            = 0x0233,
Ctrl4            = 0x0234,
Ctrl5            = 0x0235,
Ctrl6            = 0x0236,
Ctrl7            = 0x0237,
Ctrl8            = 0x0238,
Ctrl9            = 0x0239,

CtrlA            = 0x0241,
CtrlB            = 0x0242,
CtrlC            = 0x0243,
CtrlD            = 0x0244,
CtrlE            = 0x0245,
CtrlF            = 0x0246,
CtrlG            = 0x0247,
CtrlH            = 0x0248,
CtrlI            = 0x0249,
CtrlJ            = 0x024A,
CtrlK            = 0x024B,
CtrlL            = 0x024C,
CtrlM            = 0x024D,
CtrlN            = 0x024E,
CtrlO            = 0x024F,
CtrlP            = 0x0250,
CtrlQ            = 0x0251,
CtrlR            = 0x0252,
CtrlS            = 0x0253,
CtrlT            = 0x0254,
CtrlU            = 0x0255,
CtrlV            = 0x0256,
CtrlW            = 0x0257,
CtrlX            = 0x0258,
CtrlY            = 0x0259,
CtrlZ            = 0x025A,

CtrlF1           = 0x0270,
CtrlF2           = 0x0271,
CtrlF3           = 0x0272,
CtrlF4           = 0x0273,
CtrlF5           = 0x0274,
CtrlF6           = 0x0275,
CtrlF7           = 0x0276,
CtrlF8           = 0x0277,
CtrlF9           = 0x0278,
CtrlF10          = 0x0279,
CtrlF11          = 0x027A,
CtrlF12          = 0x027B,

CtrlAst          = 0x026A,
CtrlBS           = 0x0208,
CtrlDecimal      = 0x026E,
CtrlDelete       = 0x022E,
CtrlDown         = 0x0228,
CtrlEnd          = 0x0223,
CtrlEnter        = 0x020D,
CtrlEsc          = 0x021B,
CtrlHome         = 0x0224,
CtrlInsert       = 0x022D,
CtrlLeft         = 0x0225,
CtrlMinus        = 0x026D,
CtrlPause        = 0x0213,
CtrlPgDn         = 0x0222,
CtrlPgUp         = 0x0221,
CtrlPlus         = 0x026B,
CtrlPrint        = 0x022C,
CtrlRight        = 0x0227,
CtrlSlash        = 0x026F,
CtrlSpace        = 0x0220,
CtrlTab          = 0x0209,
CtrlUp           = 0x0226,

CtrlPad0         = 0x0260,
CtrlPad1         = 0x0261,
CtrlPad2         = 0x0262,
CtrlPad3         = 0x0263,
CtrlPad4         = 0x0264,
CtrlPad5         = 0x0265,
CtrlPad6         = 0x0266,
CtrlPad7         = 0x0267,
CtrlPad8         = 0x0268,
CtrlPad9         = 0x0269,

CtrlMouseLeft    = 0x0201,
CtrlMouseRight   = 0x0202,
CtrlMouseCenter  = 0x0203,
CtrlMouseLeft2   = 0x0205,
CtrlMouseRight2  = 0x0206,
CtrlMouseCenter2 = 0x0207,

Shift0           = 0x0130,
Shift1           = 0x0131,
Shift2           = 0x0132,
Shift3           = 0x0133,
Shift4           = 0x0134,
Shift5           = 0x0135,
Shift6           = 0x0136,
Shift7           = 0x0137,
Shift8           = 0x0138,
Shift9           = 0x0139,

ShiftA           = 0x0141,
ShiftB           = 0x0142,
ShiftC           = 0x0143,
ShiftD           = 0x0144,
ShiftE           = 0x0145,
ShiftF           = 0x0146,
ShiftG           = 0x0147,
ShiftH           = 0x0148,
ShiftI           = 0x0149,
ShiftJ           = 0x014A,
ShiftK           = 0x014B,
ShiftL           = 0x014C,
ShiftM           = 0x014D,
ShiftN           = 0x014E,
ShiftO           = 0x014F,
ShiftP           = 0x0150,
ShiftQ           = 0x0151,
ShiftR           = 0x0152,
ShiftS           = 0x0153,
ShiftT           = 0x0154,
ShiftU           = 0x0155,
ShiftV           = 0x0156,
ShiftW           = 0x0157,
ShiftX           = 0x0158,
ShiftY           = 0x0159,
ShiftZ           = 0x015A,

ShiftF1          = 0x0170,
ShiftF2          = 0x0171,
ShiftF3          = 0x0172,
ShiftF4          = 0x0173,
ShiftF5          = 0x0174,
ShiftF6          = 0x0175,
ShiftF7          = 0x0176,
ShiftF8          = 0x0177,
ShiftF9          = 0x0178,
ShiftF10         = 0x0179,
ShiftF11         = 0x017A,
ShiftF12         = 0x017B,

ShiftAst         = 0x016A,
ShiftBS          = 0x0108,
ShiftDecimal     = 0x016E,
ShiftDelete      = 0x012E,
ShiftDown        = 0x0128,
ShiftEnd         = 0x0123,
ShiftEnter       = 0x010D,
ShiftEsc         = 0x011B,
ShiftHome        = 0x0124,
ShiftInsert      = 0x012D,
ShiftLeft        = 0x0125,
ShiftMinus       = 0x016D,
ShiftPause       = 0x0113,
ShiftPgDn        = 0x0122,
ShiftPgUp        = 0x0121,
ShiftPlus        = 0x016B,
ShiftPrint       = 0x012C,
ShiftRight       = 0x0127,
ShiftSlash       = 0x016F,
ShiftSpace       = 0x0120,
ShiftTab         = 0x0109,
ShiftUp          = 0x0126,

ShiftPad0        = 0x0160,
ShiftPad1        = 0x0161,
ShiftPad2        = 0x0162,
ShiftPad3        = 0x0163,
ShiftPad4        = 0x0164,
ShiftPad5        = 0x0165,
ShiftPad6        = 0x0166,
ShiftPad7        = 0x0167,
ShiftPad8        = 0x0168,
ShiftPad9        = 0x0169,

ShiftMouseLeft    = 0x0101,
ShiftMouseRight   = 0x0102,
ShiftMouseCenter  = 0x0103,
ShiftMouseLeft2   = 0x0105,
ShiftMouseRight2  = 0x0106,
ShiftMouseCenter2 = 0x0107,

AltShift0        = 0x0530,
AltShift1        = 0x0531,
AltShift2        = 0x0532,
AltShift3        = 0x0533,
AltShift4        = 0x0534,
AltShift5        = 0x0535,
AltShift6        = 0x0536,
AltShift7        = 0x0537,
AltShift8        = 0x0538,
AltShift9        = 0x0539,

AltShiftA        = 0x0541,
AltShiftB        = 0x0542,
AltShiftC        = 0x0543,
AltShiftD        = 0x0544,
AltShiftE        = 0x0545,
AltShiftF        = 0x0546,
AltShiftG        = 0x0547,
AltShiftH        = 0x0548,
AltShiftI        = 0x0549,
AltShiftJ        = 0x054A,
AltShiftK        = 0x054B,
AltShiftL        = 0x054C,
AltShiftM        = 0x054D,
AltShiftN        = 0x054E,
AltShiftO        = 0x054F,
AltShiftP        = 0x0550,
AltShiftQ        = 0x0551,
AltShiftR        = 0x0552,
AltShiftS        = 0x0553,
AltShiftT        = 0x0554,
AltShiftU        = 0x0555,
AltShiftV        = 0x0556,
AltShiftW        = 0x0557,
AltShiftX        = 0x0558,
AltShiftY        = 0x0559,
AltShiftZ        = 0x055A,

AltShiftF1       = 0x0570,
AltShiftF2       = 0x0571,
AltShiftF3       = 0x0572,
AltShiftF4       = 0x0573,
AltShiftF5       = 0x0574,
AltShiftF6       = 0x0575,
AltShiftF7       = 0x0576,
AltShiftF8       = 0x0577,
AltShiftF9       = 0x0578,
AltShiftF10      = 0x0579,
AltShiftF11      = 0x057A,
AltShiftF12      = 0x057B,

AltShiftAst      = 0x056A,
AltShiftBS       = 0x0508,
AltShiftDecimal  = 0x056E,
AltShiftDelete   = 0x052E,
AltShiftDown     = 0x0528,
AltShiftEnd      = 0x0523,
AltShiftEnter    = 0x050D,
AltShiftEsc      = 0x051B,
AltShiftHome     = 0x0524,
AltShiftInsert   = 0x052D,
AltShiftLeft     = 0x0525,
AltShiftMinus    = 0x056D,
AltShiftPause    = 0x0513,
AltShiftPgDn     = 0x0522,
AltShiftPgUp     = 0x0521,
AltShiftPlus     = 0x056B,
AltShiftPrint    = 0x052C,
AltShiftRight    = 0x0527,
AltShiftSlash    = 0x056F,
AltShiftSpace    = 0x0520,
AltShiftTab      = 0x0509,
AltShiftUp       = 0x0526,

AltShiftPad0     = 0x0560,
AltShiftPad1     = 0x0561,
AltShiftPad2     = 0x0562,
AltShiftPad3     = 0x0563,
AltShiftPad4     = 0x0564,
AltShiftPad5     = 0x0565,
AltShiftPad6     = 0x0566,
AltShiftPad7     = 0x0567,
AltShiftPad8     = 0x0568,
AltShiftPad9     = 0x0569,

AltShiftMouseLeft    = 0x0501,
AltShiftMouseRight   = 0x0502,
AltShiftMouseCenter  = 0x0503,
AltShiftMouseLeft2   = 0x0505,
AltShiftMouseRight2  = 0x0506,
AltShiftMouseCenter2 = 0x0507,

CtrlShift0       = 0x0330,
CtrlShift1       = 0x0331,
CtrlShift2       = 0x0332,
CtrlShift3       = 0x0333,
CtrlShift4       = 0x0334,
CtrlShift5       = 0x0335,
CtrlShift6       = 0x0336,
CtrlShift7       = 0x0337,
CtrlShift8       = 0x0338,
CtrlShift9       = 0x0339,

CtrlShiftA       = 0x0341,
CtrlShiftB       = 0x0342,
CtrlShiftC       = 0x0343,
CtrlShiftD       = 0x0344,
CtrlShiftE       = 0x0345,
CtrlShiftF       = 0x0346,
CtrlShiftG       = 0x0347,
CtrlShiftH       = 0x0348,
CtrlShiftI       = 0x0349,
CtrlShiftJ       = 0x034A,
CtrlShiftK       = 0x034B,
CtrlShiftL       = 0x034C,
CtrlShiftM       = 0x034D,
CtrlShiftN       = 0x034E,
CtrlShiftO       = 0x034F,
CtrlShiftP       = 0x0350,
CtrlShiftQ       = 0x0351,
CtrlShiftR       = 0x0352,
CtrlShiftS       = 0x0353,
CtrlShiftT       = 0x0354,
CtrlShiftU       = 0x0355,
CtrlShiftV       = 0x0356,
CtrlShiftW       = 0x0357,
CtrlShiftX       = 0x0358,
CtrlShiftY       = 0x0359,
CtrlShiftZ       = 0x035A,

CtrlShiftF1      = 0x0370,
CtrlShiftF2      = 0x0371,
CtrlShiftF3      = 0x0372,
CtrlShiftF4      = 0x0373,
CtrlShiftF5      = 0x0374,
CtrlShiftF6      = 0x0375,
CtrlShiftF7      = 0x0376,
CtrlShiftF8      = 0x0377,
CtrlShiftF9      = 0x0378,
CtrlShiftF10     = 0x0379,
CtrlShiftF11     = 0x037A,
CtrlShiftF12     = 0x037B,

CtrlShiftAst     = 0x036A,
CtrlShiftBS      = 0x0308,
CtrlShiftDecimal = 0x036E,
CtrlShiftDelete  = 0x032E,
CtrlShiftDown    = 0x0328,
CtrlShiftEnd     = 0x0323,
CtrlShiftEnter   = 0x030D,
CtrlShiftEsc     = 0x031B,
CtrlShiftHome    = 0x0324,
CtrlShiftInsert  = 0x032D,
CtrlShiftLeft    = 0x0325,
CtrlShiftMinus   = 0x036D,
CtrlShiftPause   = 0x0313,
CtrlShiftPgDn    = 0x0322,
CtrlShiftPgUp    = 0x0321,
CtrlShiftPlus    = 0x036B,
CtrlShiftPrint   = 0x032C,
CtrlShiftRight   = 0x0327,
CtrlShiftSlash   = 0x036F,
CtrlShiftSpace   = 0x0320,
CtrlShiftTab     = 0x0309,
CtrlShiftUp      = 0x0326,

CtrlShiftPad0    = 0x0360,
CtrlShiftPad1    = 0x0361,
CtrlShiftPad2    = 0x0362,
CtrlShiftPad3    = 0x0363,
CtrlShiftPad4    = 0x0364,
CtrlShiftPad5    = 0x0365,
CtrlShiftPad6    = 0x0366,
CtrlShiftPad7    = 0x0367,
CtrlShiftPad8    = 0x0368,
CtrlShiftPad9    = 0x0369,

CtrlShiftMouseLeft    = 0x0301,
CtrlShiftMouseRight   = 0x0302,
CtrlShiftMouseCenter  = 0x0303,
CtrlShiftMouseLeft2   = 0x0305,
CtrlShiftMouseRight2  = 0x0306,
CtrlShiftMouseCenter2 = 0x0307,

CtrlAlt0         = 0x0630,
CtrlAlt1         = 0x0631,
CtrlAlt2         = 0x0632,
CtrlAlt3         = 0x0633,
CtrlAlt4         = 0x0634,
CtrlAlt5         = 0x0635,
CtrlAlt6         = 0x0636,
CtrlAlt7         = 0x0637,
CtrlAlt8         = 0x0638,
CtrlAlt9         = 0x0639,

CtrlAltA         = 0x0641,
CtrlAltB         = 0x0642,
CtrlAltC         = 0x0643,
CtrlAltD         = 0x0644,
CtrlAltE         = 0x0645,
CtrlAltF         = 0x0646,
CtrlAltG         = 0x0647,
CtrlAltH         = 0x0648,
CtrlAltI         = 0x0649,
CtrlAltJ         = 0x064A,
CtrlAltK         = 0x064B,
CtrlAltL         = 0x064C,
CtrlAltM         = 0x064D,
CtrlAltN         = 0x064E,
CtrlAltO         = 0x064F,
CtrlAltP         = 0x0650,
CtrlAltQ         = 0x0651,
CtrlAltR         = 0x0652,
CtrlAltS         = 0x0653,
CtrlAltT         = 0x0654,
CtrlAltU         = 0x0655,
CtrlAltV         = 0x0656,
CtrlAltW         = 0x0657,
CtrlAltX         = 0x0658,
CtrlAltY         = 0x0659,
CtrlAltZ         = 0x065A,

CtrlAltF1        = 0x0670,
CtrlAltF2        = 0x0671,
CtrlAltF3        = 0x0672,
CtrlAltF4        = 0x0673,
CtrlAltF5        = 0x0674,
CtrlAltF6        = 0x0675,
CtrlAltF7        = 0x0676,
CtrlAltF8        = 0x0677,
CtrlAltF9        = 0x0678,
CtrlAltF10       = 0x0679,
CtrlAltF11       = 0x067A,
CtrlAltF12       = 0x067B,

CtrlAltAst       = 0x066A,
CtrlAltBS        = 0x0608,
CtrlAltDecimal   = 0x066E,
CtrlAltDelete    = 0x062E,
CtrlAltDown      = 0x0628,
CtrlAltEnd       = 0x0623,
CtrlAltEnter     = 0x060D,
CtrlAltEsc       = 0x061B,
CtrlAltHome      = 0x0624,
CtrlAltInsert    = 0x062D,
CtrlAltLeft      = 0x0625,
CtrlAltMinus     = 0x066D,
CtrlAltPause     = 0x0613,
CtrlAltPgDn      = 0x0622,
CtrlAltPgUp      = 0x0621,
CtrlAltPlus      = 0x066B,
CtrlAltPrint     = 0x062C,
CtrlAltRight     = 0x0627,
CtrlAltSlash     = 0x066F,
CtrlAltSpace     = 0x0620,
CtrlAltTab       = 0x0609,
CtrlAltUp        = 0x0626,

CtrlAltPad0      = 0x0660,
CtrlAltPad1      = 0x0661,
CtrlAltPad2      = 0x0662,
CtrlAltPad3      = 0x0663,
CtrlAltPad4      = 0x0664,
CtrlAltPad5      = 0x0665,
CtrlAltPad6      = 0x0666,
CtrlAltPad7      = 0x0667,
CtrlAltPad8      = 0x0668,
CtrlAltPad9      = 0x0669,

CtrlAltMouseLeft    = 0x0601,
CtrlAltMouseRight   = 0x0602,
CtrlAltMouseCenter  = 0x0603,
CtrlAltMouseLeft2   = 0x0605,
CtrlAltMouseRight2  = 0x0606,
CtrlAltMouseCenter2 = 0x0607

};