/* Release 0.01a*/
/*
 ***************************************************************************
 *                                                                         *
 *      os2func.h    - Definitions os2 specific functions.                 *
 *                                                                         *
 *      Copyright(C) 1992-92 Clarion Software Corporation.                 *
 *                                                                         *
 *      LastMod 17 Nov 92 GH                                               *
 *      Created  2 Nov 92 GH                                               *
 *                                                                         *
 ***************************************************************************/

#ifdef __cplusplus
extern "C" {
#endif

/*
 * Filing system functions....
 */
ssize_t _OSread(int CurHandle, void * ptr, size_t NumBytes);
ssize_t _OSwrite(int CurHandle, const void * ptr, size_t NumBytes);
long    _OSseek(int CurHandle, long offset, int whence);
long    _OStell(int CurHandle);
int     _OSopen(const char * Filename,   int access);
int     _OScreate(const char * Filename, int access, int permission);
int     _OSclose(int CurHandle);
int     isatty(int FileHandle);
BOOL    _OSFileExists(const char * FileName);
int     _OSdelete(const char * FileName);
int     _OSrename(const char * OldName, const char * NewName);
int     _OSDupHandle(int CurHandle);

void    _OSAllocMoreHandles(int * TotalHandles, int Increase);

int     _OSDup2Handle(int OldHandle, int NewHandle);
int     _OSChangeOpenFileMode(int handle, int mode);

/*
 * Heap manager functions.
 */
void *  _OSGetBlock(size_t BlockSize);
void    _OSFreeBlock(void * ptr);
void *  _OSExpandBlock(void * ptr, size_t NewSize);

#ifdef __cplusplus
}
#endif
