#if !defined( _OLE16_H_ )
#define _OLE16_H_
#define __stdcall cdecl
#define __RPC_FAR
#define HUGEP huge
#define FARSTRUCT
#define WINOLEAPI WINAPI
#define WINOLEAPI_(type) type WINAPI
#define WINOLEAUTAPI WINAPI
#define WINOLEAUTAPI_(type) type WINAPI
#define STDAPI WINAPI
#define STDAPI_(type) type WINAPI
#define EXTERN_C extern "C"

// from winerror.h
#define GetScode(hr) ((SCODE) (hr))
#define ResultFromScode(sc) ((HRESULT) (sc))
#define S_FALSE             (0x00000001L)
#define S_OK                (0x00000000L)
#define NOERROR             S_OK
#define ERROR_SUCCESS       0L

#define E_NOINTERFACE                    0x80004002L
#define E_FAIL                           0x80004005L
#define E_UNEXPECTED                     0x8000FFFFL
#define E_NOTIMPL                        0x80004001L
#define E_INVALIDARG                     0x80070057L
#define INPLACE_E_NOTOOLSPACE            0x800401A1L
#define MK_E_NOOBJECT                    0x800401E5L
#define OLE_E_ADVISENOTSUPPORTED         0x80040003L
#define OLE_E_NOCONNECTION               0x80040004L
#define OLE_E_NOTRUNNING                 0x80040005L
#define DV_E_FORMATETC                   0x80040064L
#define DATA_S_SAMEFORMATETC             0x00040130L
#define DISP_E_PARAMNOTFOUND             0x80020004L
#define DISP_E_MEMBERNOTFOUND            0x80020003L
#define DISP_E_TYPEMISMATCH              0x80020005L
#define DISP_E_UNKNOWNNAME               0x80020006L
#define DISP_E_EXCEPTION                 0x80020009L

// from wtypes.h
#define MAX_PATH          260
#define TEXT(a) a
typedef char CHAR;
typedef wchar_t WCHAR;
typedef CHAR TCHAR;
typedef DWORD ULONG;
typedef unsigned short USHORT;
typedef short int SHORT;
typedef DWORD LCID;
typedef DWORD HKEY;
typedef const RECT FAR *LPCRECT;
typedef int HFILE;
#define FILE_BEGIN           0
#define FILE_CURRENT         1
#define FILE_END             2
#define LOCALE_SYSTEM_DEFAULT 0L

typedef /* [transmit] */ void __RPC_FAR *HMETAFILEPICT;
typedef /* [transmit] */ void __RPC_FAR *HENHMETAFILE;
typedef char OLECHAR;
typedef /* [string] */ OLECHAR __RPC_FAR *LPOLESTR;
typedef /* [string] */ const OLECHAR __RPC_FAR *LPCOLESTR;
typedef /* [string] */ TCHAR __RPC_FAR *LPTSTR;

typedef LONG HRESULT;
typedef LONG SCODE;

typedef struct _ULARGE_INTEGER {
    DWORD LowPart;
    DWORD HighPart;
} ULARGE_INTEGER;

typedef struct _LARGE_INTEGER {
    DWORD LowPart;
    long int HighPart;
} LARGE_INTEGER;

typedef
enum tagCLSCTX
    {	CLSCTX_INPROC_SERVER	= 1,
	CLSCTX_INPROC_HANDLER	= 2,
	CLSCTX_LOCAL_SERVER	= 4,
	CLSCTX_INPROC_SERVER16	= 8
    }	CLSCTX;

typedef
enum tagMEMCTX
    {	MEMCTX_TASK	= 1,
	MEMCTX_SHARED	= 2,
	MEMCTX_MACSYSTEM	= 3,
	MEMCTX_UNKNOWN	= -1,
	MEMCTX_SAME	= -2
    }	MEMCTX;

typedef
enum tagSTGC
    {	STGC_DEFAULT	= 0,
	STGC_OVERWRITE	= 1,
	STGC_ONLYIFCURRENT	= 2,
	STGC_DANGEROUSLYCOMMITMERELYTODISKCACHE	= 4
    }	STGC;

typedef
enum tagDVASPECT
    {	DVASPECT_CONTENT	= 1,
	DVASPECT_THUMBNAIL	= 2,
	DVASPECT_ICON	= 4,
	DVASPECT_DOCPRINT	= 8
    }	DVASPECT;

typedef struct  _FILETIME
    {
    DWORD dwLowDateTime;
    DWORD dwHighDateTime;
    }	FILETIME;

typedef struct  _POINTL
    {
    LONG x;
    LONG y;
    }	POINTL;

typedef struct  _RECTL
    {
    LONG left;
    LONG top;
    LONG right;
    LONG bottom;
    }	RECTL;

typedef struct tagLICINFO FAR* LPLICINFO;

typedef struct _RECTL __RPC_FAR *PRECTL;
typedef struct _RECTL __RPC_FAR *LPRECTL;
typedef const RECTL __RPC_FAR *LPCRECTL;

typedef struct  tagSIZEL
    {
    LONG cx;
    LONG cy;
    }	SIZEL;

typedef struct tagSIZEL __RPC_FAR *PSIZEL;
typedef struct tagSIZEL __RPC_FAR *LPSIZEL;

			/* size is 16 */
typedef struct  _GUID
    {
    DWORD Data1;
    WORD Data2;
    WORD Data3;
    BYTE Data4[ 8 ];
    }	GUID;
typedef GUID __RPC_FAR *LPGUID;

			/* size is 20 */
typedef struct  _OBJECTID
    {
    GUID Lineage;
    unsigned long Uniquifier;
    }	OBJECTID;

typedef GUID IID;
typedef GUID CLSID;

typedef IID   __RPC_FAR *LPIID;
typedef CLSID __RPC_FAR *LPCLSID;

#define IID_NULL            GUID_NULL
#define CLSID_NULL          GUID_NULL

#define REFGUID             const GUID &
#define REFIID              const IID &
#define REFCLSID            const CLSID &

inline BOOL IsEqualGUID(REFGUID rguid1, REFGUID rguid2)
{
    return !memcmp(&rguid1, &rguid2, sizeof(GUID));
}
#define IsEqualIID(riid1, riid2) IsEqualGUID(riid1, riid2)
#define IsEqualCLSID(rclsid1, rclsid2) IsEqualGUID(rclsid1, rclsid2)

// from OBJBASE.H
#define STDMETHODCALLTYPE       cdecl
#define interface struct
#define STDMETHOD(method)       virtual HRESULT STDMETHODCALLTYPE method
#define STDMETHOD_(type,method) virtual type STDMETHODCALLTYPE method
#define STDMETHODIMP            HRESULT STDMETHODCALLTYPE
#define STDMETHODIMP_(type)     type STDMETHODCALLTYPE
#define PURE                    = 0
#define THIS_
#define THIS                    void
#define DECLARE_INTERFACE(iface)    interface iface
#define DECLARE_INTERFACE_(iface, baseiface)    interface iface : public baseiface

/* Storage instantiation modes */
#define STGM_DIRECT             0x00000000L
#define STGM_TRANSACTED         0x00010000L
#define STGM_SIMPLE             0x08000000L

#define STGM_READ               0x00000000L
#define STGM_WRITE              0x00000001L
#define STGM_READWRITE          0x00000002L

#define STGM_SHARE_DENY_NONE    0x00000040L
#define STGM_SHARE_DENY_READ    0x00000030L
#define STGM_SHARE_DENY_WRITE   0x00000020L
#define STGM_SHARE_EXCLUSIVE    0x00000010L

#define STGM_PRIORITY           0x00040000L
#define STGM_DELETEONRELEASE    0x04000000L
#if (WINVER >= 400)
#define STGM_NOSCRATCH          0x00100000L
#endif /* WINVER */

#define STGM_CREATE             0x00001000L
#define STGM_CONVERT            0x00020000L
#define STGM_FAILIFTHERE        0x00000000L

#ifndef INITGUID
#define DEFINE_GUID(name, l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8) \
    EXTERN_C const GUID CDECL name
#else

#define DEFINE_GUID(name, l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8) \
        EXTERN_C const GUID CDECL name;  \
        const GUID CDECL name \
                = { l, w1, w2, { b1, b2,  b3,  b4,  b5,  b6,  b7,  b8 } }
#endif // INITGUID

#define DEFINE_OLEGUID(name, l, w1, w2) \
    DEFINE_GUID(name, l, w1, w2, 0xC0,0,0,0,0,0,0,0x46)

// from objidl.h / oleidl7.h
typedef interface IUnknown IUnknown;
typedef interface IStream IStream;
typedef interface IPersistStream IPersistStream;
typedef interface IStorage IStorage;
typedef interface IPersistStorage IPersistStorage;
typedef interface IEnumSTATSTG IEnumSTATSTG;
typedef interface IEnumMoniker IEnumMoniker;

typedef interface IEnumFORMATETC IEnumFORMATETC;
typedef interface IAdviseSink IAdviseSink;
typedef interface IEnumSTATDATA IEnumSTATDATA;
typedef interface IMoniker IMoniker;
typedef interface IOleObject IOleObject;
typedef interface IViewObject2 IViewObject2;
typedef interface IBindCtx IBindCtx;
typedef interface IEnumUnknown IEnumUnknown;
typedef interface IOleContainer IOleContainer;
typedef interface IDataObject IDataObject;
typedef interface IOleItemContainer IOleItemContainer;
typedef interface IOleClientSite IOleClientSite;
typedef interface IOleInPlaceFrame IOleInPlaceFrame;
typedef interface IOleInPlaceActiveObject IOleInPlaceActiveObject;
typedef interface IOleInPlaceObject IOleInPlaceObject;
typedef interface IOleInPlaceSite IOleInPlaceSite;
typedef interface IOleInPlaceUIWindow IOleInPlaceUIWindow;
typedef interface IOleInPlaceFrame IOleInPlaceFrame;
typedef interface IDropTarget IDropTarget;
typedef interface IDropSource IDropSource;
typedef interface IOleAdviseHolder IOleAdviseHolder;
typedef interface IClassFactory IClassFactory;
typedef interface IEnumOLEVERB IEnumOLEVERB;
typedef interface ILockBytes ILockBytes;
typedef interface IMalloc IMalloc;
typedef interface ITypeInfo ITypeInfo;
typedef interface IViewObject IViewObject;
typedef interface IOleLink IOleLink;
typedef interface IOleControl IOleControl;
typedef interface IOleControlSite IOleControlSite;
typedef interface IConnectionPointContainer IConnectionPointContainer;
typedef interface IConnectionPoint IConnectionPoint;
typedef interface IEnumConnectionPoints IEnumConnectionPoints;
typedef interface IEnumConnections IEnumConnections;
typedef interface ITypeInfo ITypeInfo;
typedef interface IProvideClassInfo IProvideClassInfo;
typedef interface IPropertyNotifySink;
typedef interface ITypeComp;
typedef interface IPicture;
typedef interface IClassFactory2;

typedef
enum tagOLECLOSE
    {	OLECLOSE_SAVEIFDIRTY	= 0,
	OLECLOSE_NOSAVE	= 1,
	OLECLOSE_PROMPTSAVE	= 2
    }	OLECLOSE;

typedef
enum tagOLEWHICHMK
    {	OLEWHICHMK_CONTAINER	= 1,
	OLEWHICHMK_OBJREL	= 2,
	OLEWHICHMK_OBJFULL	= 3
    }	OLEWHICHMK;

typedef
enum tagADVF
    {	ADVF_NODATA	= 1,
	ADVF_PRIMEFIRST	= 2,
	ADVF_ONLYONCE	= 4,
	ADVF_DATAONSTOP	= 64,
	ADVFCACHE_NOHANDLER	= 8,
	ADVFCACHE_FORCEBUILTIN	= 16,
	ADVFCACHE_ONSAVE	= 32
    }	ADVF;

typedef
enum tagOLERENDER
    {	OLERENDER_NONE	= 0,
	OLERENDER_DRAW	= 1,
	OLERENDER_FORMAT	= 2,
	OLERENDER_ASIS	= 3
    }	OLERENDER;

typedef
enum tagOLEUPDATE
    {	OLEUPDATE_ALWAYS	= 1,
	OLEUPDATE_ONCALL	= 3
    }	OLEUPDATE;

typedef
enum tagUSERCLASSTYPE
    {	USERCLASSTYPE_FULL	= 1,
	USERCLASSTYPE_SHORT	= 2,
	USERCLASSTYPE_APPNAME	= 3
    }	USERCLASSTYPE;

typedef struct  tagSTATSTG
    {
    LPOLESTR pwcsName;
    DWORD type;
    ULARGE_INTEGER cbSize;
    FILETIME mtime;
    FILETIME ctime;
    FILETIME atime;
    DWORD grfMode;
    DWORD grfLocksSupported;
    CLSID clsid;
    DWORD grfStateBits;
    DWORD reserved;
    }	STATSTG;

typedef struct  tagOBJECTDESCRIPTOR
    {
    ULONG cbSize;
    CLSID clsid;
    DWORD dwDrawAspect;
    SIZEL sizel;
    POINTL pointl;
    DWORD dwStatus;
    DWORD dwFullUserTypeName;
    DWORD dwSrcOfCopy;
    }	OBJECTDESCRIPTOR;

typedef struct tagOBJECTDESCRIPTOR __RPC_FAR *POBJECTDESCRIPTOR;

typedef struct tagOBJECTDESCRIPTOR __RPC_FAR *LPOBJECTDESCRIPTOR;

			/* size is 12 */
typedef struct  tagDVTARGETDEVICE
    {
    DWORD tdSize;
    WORD tdDriverNameOffset;
    WORD tdDeviceNameOffset;
    WORD tdPortNameOffset;
    WORD tdExtDevmodeOffset;
    /* [size_is] */ BYTE tdData[ 1 ];
    }	DVTARGETDEVICE;

			/* size is 2 */
typedef WORD CLIPFORMAT;

		/* size is 4 */
typedef CLIPFORMAT __RPC_FAR *LPCLIPFORMAT;

typedef struct  tagFORMATETC
    {
    CLIPFORMAT cfFormat;
    /* [unique] */ DVTARGETDEVICE __RPC_FAR *ptd;
    DWORD dwAspect;
    LONG lindex;
    DWORD tymed;
    }	FORMATETC;

			/* size is 4 */
typedef struct tagFORMATETC __RPC_FAR *LPFORMATETC;

typedef /* [transmit] */ OLECHAR __RPC_FAR *__RPC_FAR *SNB;

typedef DWORD HREFTYPE;
typedef unsigned short VARTYPE;

typedef struct  tagIDLDESC
    {
    unsigned long dwReserved;
    unsigned short wIDLFlags;
    }	IDLDESC;

struct TYPEDESC
    {
      union
      {
        /* [case] */ struct tagARRAYDESC __RPC_FAR *lpadesc;
        /* [case] */ struct tagTYPEDESC __RPC_FAR *lptdesc;
        /* [case] */ HREFTYPE hreftype;
      }	;
      VARTYPE vt;
    };

enum TYPEKIND
    {	TKIND_ENUM	= 0,
	TKIND_RECORD	= TKIND_ENUM + 1,
	TKIND_MODULE	= TKIND_RECORD + 1,
	TKIND_INTERFACE	= TKIND_MODULE + 1,
	TKIND_DISPATCH	= TKIND_INTERFACE + 1,
	TKIND_COCLASS	= TKIND_DISPATCH + 1,
	TKIND_ALIAS	= TKIND_COCLASS + 1,
	TKIND_UNION	= TKIND_ALIAS + 1,
	TKIND_MAX	= TKIND_UNION + 1
    };

typedef LONG DISPID;
typedef DISPID MEMBERID;
struct  TYPEATTR
    {
    GUID guid;
    LCID lcid;
    DWORD dwReserved;
    MEMBERID memidConstructor;
    MEMBERID memidDestructor;
    LPOLESTR lpstrSchema;
    ULONG cbSizeInstance;
    TYPEKIND typekind;
    WORD cFuncs;
    WORD cVars;
    WORD cImplTypes;
    WORD cbSizeVft;
    WORD cbAlignment;
    WORD wTypeFlags;
    WORD wMajorVerNum;
    WORD wMinorVerNum;
    TYPEDESC tdescAlias;
    IDLDESC idldescType;
    };

			/* size is 4 */
typedef struct TYPEATTR __RPC_FAR *LPTYPEATTR;

			/* size is 4 */
typedef /* [unique] */ IUnknown __RPC_FAR *LPUNKNOWN;
typedef /* [unique] */ IEnumFORMATETC __RPC_FAR *LPENUMFORMATETC;
typedef IAdviseSink __RPC_FAR *LPADVISESINK;
typedef /* [unique] */ IEnumSTATDATA __RPC_FAR *LPENUMSTATDATA;
typedef /* [unique] */ IMoniker __RPC_FAR *LPMONIKER;
typedef /* [unique] */ IStorage __RPC_FAR *LPSTORAGE;
typedef /* [unique] */ IPersistStorage __RPC_FAR *LPPERSISTSTORAGE;
typedef /* [unique] */ IStream __RPC_FAR *LPSTREAM;
typedef /* [unique] */ IPersistStream __RPC_FAR *LPPERSISTSTREAM;
typedef /* [unique] */ IOleObject __RPC_FAR *LPOLEOBJECT;
typedef /* [unique] */ IViewObject2 __RPC_FAR *LPVIEWOBJECT2;
typedef /* [unique] */ IBindCtx __RPC_FAR *LPBC;
typedef /* [unique] */ IBindCtx __RPC_FAR *LPBINDCTX;
typedef /* [unique] */ IEnumUnknown __RPC_FAR *LPENUMUNKNOWN;
typedef /* [unique] */ IOleContainer __RPC_FAR *LPOLECONTAINER;
typedef /* [unique] */ IOleInPlaceActiveObject __RPC_FAR *LPOLEINPLACEACTIVEOBJECT;
typedef /* [unique] */ IOleInPlaceObject __RPC_FAR *LPOLEINPLACEOBJECT;
typedef /* [unique] */ IOleInPlaceUIWindow __RPC_FAR *LPOLEINPLACEUIWINDOW;
typedef /* [unique] */ IOleInPlaceFrame __RPC_FAR *LPOLEINPLACEFRAME;
typedef /* [unique] */ IOleClientSite __RPC_FAR *LPOLECLIENTSITE;
typedef /* [unique] */ IDataObject __RPC_FAR *LPDATAOBJECT;
typedef /* [unique] */ IDropTarget __RPC_FAR *LPDROPTARGET;
typedef /* [unique] */ IDropSource __RPC_FAR *LPDROPSOURCE;
typedef /* [unique] */ IOleAdviseHolder __RPC_FAR *LPOLEADVISEHOLDER;
typedef /* [unique] */ IClassFactory __RPC_FAR *LPCLASSFACTORY;
typedef /* [unique] */ IEnumOLEVERB __RPC_FAR *LPENUMOLEVERB;
typedef /* [unique] */ ILockBytes __RPC_FAR *LPLOCKBYTES;
typedef /* [unique] */ IMalloc __RPC_FAR *LPMALLOC;
typedef /* [unique] */ IViewObject __RPC_FAR *LPVIEWOBJECT;
typedef /* [unique] */ IOleLink __RPC_FAR *LPOLELINK;

typedef IOleControl FAR* LPOLECONTROL;
typedef IOleControlSite FAR* LPOLECONTROLSITE;
typedef IConnectionPointContainer FAR* LPCONNECTIONPOINTCONTAINER;
typedef IConnectionPoint FAR* LPCONNECTIONPOINT;
typedef IEnumConnectionPoints FAR* LPENUMCONNECTIONPOINTS;
typedef IEnumConnections FAR* LPENUMCONNECTIONS;
typedef ITypeInfo FAR* LPTYPEINFO;
typedef IProvideClassInfo FAR* LPPROVIDECLASSINFO;
typedef ITypeComp FAR* LPTYPECOMP;
typedef IPicture FAR* LPPICTURE;
typedef IClassFactory2 FAR* LPCLASSFACTORY2;

typedef struct tagPOINTF
{
	float x;
	float y;

} POINTF;

#define PICTYPE_UNINITIALIZED   ((UINT)-1)
#define PICTYPE_NONE        0
#define PICTYPE_BITMAP      1
#define PICTYPE_METAFILE    2
#define PICTYPE_ICON        3

struct PICTDESC
{
	UINT cbSizeofstruct;
	UINT picType;
	union
	{
		struct
		{
			HBITMAP   hbitmap;        // Bitmap
			HPALETTE  hpal;           // Accompanying palette
		} bmp;

		struct
		{
			HMETAFILE hmeta;          // Metafile
			int       xExt;
			int       yExt;           // Extent
		} wmf;

		struct
		{
			HICON hicon;              // Icon
		} icon;
	};

};

// CONTROLINFO structure

typedef struct tagCONTROLINFO
{
	ULONG cb;       // Structure size
	HACCEL hAccel;  // Control mnemonics
	USHORT cAccel;  // Number of entries in mnemonics table
	DWORD dwFlags;  // Flags chosen from below

} CONTROLINFO;

#define CTRLINFO_EATS_RETURN    1   // Control doesn't send Return to container
#define CTRLINFO_EATS_ESCAPE    2   // Control doesn't send Escape to container

typedef struct tagCONTROLINFO FAR* LPCONTROLINFO;

typedef /* [v1_enum] */
enum tagTYMED
    {	TYMED_HGLOBAL	= 1,
	TYMED_FILE	= 2,
	TYMED_ISTREAM	= 4,
	TYMED_ISTORAGE	= 8,
	TYMED_GDI	= 16,
	TYMED_MFPICT	= 32,
	TYMED_ENHMF	= 64,
	TYMED_NULL	= 0
    }	TYMED;

			/* size is 12 */
typedef struct  tagSTGMEDIUM
    {
    DWORD tymed;
    /* [switch_is][switch_type] */ union
        {
        /* [case] */ HBITMAP hBitmap;
        /* [case] */ HMETAFILEPICT hMetaFilePict;
        /* [case] */ HENHMETAFILE hEnhMetaFile;
        /* [case] */ HGLOBAL hGlobal;
        /* [case] */ LPOLESTR lpszFileName;
        /* [case] */ IStream __RPC_FAR *pstm;
        /* [case] */ IStorage __RPC_FAR *pstg;
        /* [default] */  /* Empty union arm */
        }	;
    /* [unique] */ IUnknown __RPC_FAR *pUnkForRelease;
    }	STGMEDIUM;

typedef STGMEDIUM __RPC_FAR *LPSTGMEDIUM;

typedef RECT BORDERWIDTHS;
typedef const RECT FAR *LPCBORDERWIDTHS;
typedef HGLOBAL HOLEMENU;

typedef struct  tagOleMenuGroupWidths
    {
    LONG width[ 6 ];
    }	OLEMENUGROUPWIDTHS;

			/* size is 4 */
typedef struct tagOleMenuGroupWidths __RPC_FAR *LPOLEMENUGROUPWIDTHS;

typedef struct  tagOIFI
    {
    UINT cb;
    BOOL fMDIApp;
    HWND hwndFrame;
    HACCEL haccel;
    UINT cAccelEntries;
    }	OLEINPLACEFRAMEINFO;

			/* size is 4 */
typedef struct tagOIFI __RPC_FAR *LPOLEINPLACEFRAMEINFO;

// from OLEAUTO.H
#define	DISPID_UNKNOWN	( -1 )
#define	DISPID_VALUE	( 0 )
#define	DISPID_PROPERTYPUT	( -3 )
#define	DISPID_NEWENUM	( -4 )
#define	DISPID_EVALUATE	( -5 )
#define	DISPID_CONSTRUCTOR	( -6 )
#define	DISPID_DESTRUCTOR	( -7 )
#define	DISPID_COLLECT	( -8 )

/* Flags for IDispatch::Invoke */
#define DISPATCH_METHOD     0x1
#define DISPATCH_PROPERTYGET    0x2
#define DISPATCH_PROPERTYPUT    0x4
#define DISPATCH_PROPERTYPUTREF 0x8

typedef interface IDispatch IDispatch;

typedef IDispatch FAR* LPDISPATCH;


// from OAIDL.H

struct VARDESC;

typedef struct  tagSAFEARRAYBOUND
    {
    ULONG cElements;
    LONG lLbound;
    }	SAFEARRAYBOUND;

typedef struct tagSAFEARRAYBOUND __RPC_FAR *LPSAFEARRAYBOUND;

typedef struct FARSTRUCT tagSAFEARRAY {
    unsigned short cDims;
    unsigned short fFeatures;
    unsigned short cbElements;
    unsigned short cLocks;
    unsigned long handle;               // unused but kept for compatiblity
    void HUGEP* pvData;
    SAFEARRAYBOUND rgsabound[1];
} SAFEARRAY, FAR* LPSAFEARRAY;

#undef VARIANT  // in case ClaUFO included

typedef short VARIANT_BOOL;
typedef double DATE;
typedef OLECHAR __RPC_FAR *BSTR;

typedef struct tagEXCEPINFO {
    WORD wCode;
    WORD wReserved;
    BSTR bstrSource;
    BSTR bstrDescription;
    BSTR bstrHelpFile;
    DWORD dwHelpContext;
    void __RPC_FAR * pvReserved;
    HRESULT (__stdcall __RPC_FAR * pfnDeferredFillIn)(struct tagEXCEPINFO __RPC_FAR *);
    SCODE scode;
}  EXCEPINFO, __RPC_FAR * LPEXCEPINFO;

typedef
enum tagDATADIR
    {	DATADIR_GET	= 1,
	DATADIR_SET	= 2
    }	DATADIR;

typedef union tagCY {
    struct {
        unsigned long Lo;
        long      Hi;
    } _u;
//    LONGLONG int64;
} CY;

typedef unsigned short VARTYPE;
typedef struct tagVARIANT VARIANT;

#define	IMPLTYPEFLAG_FDEFAULT	( 0x1 )
#define	IMPLTYPEFLAG_FSOURCE	( 0x2 )
#define	IMPLTYPEFLAG_FRESTRICTED	( 0x4 )

struct tagVARIANT{
    VARTYPE vt;
    WORD wReserved1;
    WORD wReserved2;
    WORD wReserved3;
    union
    {
      long          lVal;           /* VT_I4                */
      unsigned char bVal;           /* VT_UI1               */
      short         iVal;           /* VT_I2                */
      float         fltVal;         /* VT_R4                */
      double        dblVal;         /* VT_R8                */
      VARIANT_BOOL  bool;           /* VT_BOOL              */
      SCODE         scode;          /* VT_ERROR             */
      CY            cyVal;          /* VT_CY                */
      DATE          date;           /* VT_DATE              */
      BSTR          bstrVal;        /* VT_BSTR              */
      IUnknown      *punkVal;       /* VT_UNKNOWN           */
      IDispatch     *pdispVal;      /* VT_DISPATCH          */
      SAFEARRAY     *parray;        /* VT_ARRAY|*           */
      unsigned char *pbVal;         /* VT_BYREF|VT_UI1      */
      short         *piVal;         /* VT_BYREF|VT_I2       */
      long          *plVal;         /* VT_BYREF|VT_I4       */
      float         *pfltVal;       /* VT_BYREF|VT_R4       */
      double        *pdblVal;       /* VT_BYREF|VT_R8       */
      VARIANT_BOOL  *pbool;         /* VT_BYREF|VT_BOOL     */
      SCODE         *pscode;        /* VT_BYREF|VT_ERROR    */
      CY            *pcyVal;        /* VT_BYREF|VT_CY       */
      DATE          *pdate;         /* VT_BYREF|VT_DATE     */
      BSTR          *pbstrVal;      /* VT_BYREF|VT_BSTR     */
      IUnknown      **ppunkVal;     /* VT_BYREF|VT_UNKNOWN  */
      IDispatch     **ppdispVal;    /* VT_BYREF|VT_DISPATCH */
      SAFEARRAY     **pparray;      /* VT_BYREF|VT_ARRAY|*  */
      VARIANT       *pvarVal;       /* VT_BYREF|VT_VARIANT  */
      void     * byref;             /* Generic ByRef        */
    };
};
typedef struct tagVARIANT __RPC_FAR *LPVARIANT;
typedef struct tagVARIANT VARIANTARG;

enum VARENUM
    {	VT_EMPTY	= 0,
	VT_NULL	= 1,
	VT_I2	= 2,
	VT_I4	= 3,
	VT_R4	= 4,
	VT_R8	= 5,
	VT_CY	= 6,
	VT_DATE	= 7,
	VT_BSTR	= 8,
	VT_DISPATCH	= 9,
	VT_ERROR	= 10,
	VT_BOOL	= 11,
	VT_VARIANT	= 12,
	VT_UNKNOWN	= 13,
	VT_I1	= 16,
	VT_UI1	= 17,
	VT_UI2	= 18,
	VT_UI4	= 19,
	VT_I8	= 20,
	VT_UI8	= 21,
	VT_INT	= 22,
	VT_UINT	= 23,
	VT_VOID	= 24,
	VT_HRESULT	= 25,
	VT_PTR	= 26,
	VT_SAFEARRAY	= 27,
	VT_CARRAY	= 28,
	VT_USERDEFINED	= 29,
	VT_LPSTR	= 30,
	VT_LPWSTR	= 31,
	VT_FILETIME	= 64,
	VT_BLOB	= 65,
	VT_STREAM	= 66,
	VT_STORAGE	= 67,
	VT_STREAMED_OBJECT	= 68,
	VT_STORED_OBJECT	= 69,
	VT_BLOB_OBJECT	= 70,
	VT_CF	= 71,
	VT_CLSID	= 72
    };

#define	VT_VECTOR	( 0x1000 )
#define	VT_ARRAY	( 0x2000 )
#define	VT_BYREF	( 0x4000 )

/* Variant access macros */
#define V_UNION(X, Y)    ((X)->Y)
#define V_VT(X)          ((X)->vt)
#define V_I2(X)          V_UNION(X, iVal)
#define V_I4(X)          V_UNION(X, lVal)
#define V_BOOL(X)        V_UNION(X, bool)
#define V_BSTR(X)        V_UNION(X, bstrVal)


typedef struct  tagDISPPARAMS
    {
    /* [size_is] */ VARIANTARG __RPC_FAR *rgvarg;
    /* [size_is] */ DISPID __RPC_FAR *rgdispidNamedArgs;
    UINT cArgs;
    UINT cNamedArgs;
    }	DISPPARAMS;

typedef /* [transmit] */
enum tagINVOKEKIND
    {	INVOKE_FUNC	= 1,
	INVOKE_PROPERTYGET	= 2,
	INVOKE_PROPERTYPUT	= 4,
	INVOKE_PROPERTYPUTREF	= 8
    }	INVOKEKIND;

typedef
enum tagOLEMISC
    {	OLEMISC_RECOMPOSEONRESIZE	= 1,
	OLEMISC_ONLYICONIC	= 2,
	OLEMISC_INSERTNOTREPLACE	= 4,
	OLEMISC_STATIC	= 8,
	OLEMISC_CANTLINKINSIDE	= 16,
	OLEMISC_CANLINKBYOLE1	= 32,
	OLEMISC_ISLINKOBJECT	= 64,
	OLEMISC_INSIDEOUT	= 128,
	OLEMISC_ACTIVATEWHENVISIBLE	= 256,
	OLEMISC_RENDERINGISDEVICEINDEPENDENT	= 512
    }	OLEMISC;

#define OLEMISC_INVISIBLEATRUNTIME  0x00000400
#define OLEMISC_ALWAYSRUN           0x00000800
#define OLEMISC_ACTSLIKEBUTTON      0x00001000
#define OLEMISC_ACTSLIKELABEL       0x00002000
#define OLEMISC_NOUIACTIVATE        0x00004000
#define OLEMISC_ALIGNABLE           0x00008000
#define OLEMISC_SIMPLEFRAME         0x00010000
#define OLEMISC_SETCLIENTSITEFIRST  0x00020000
#define OLEMISC_IMEMODE				0x00040000

/*---------------------------------------------------------------------*/
/*                           VARIANT API                               */
/*---------------------------------------------------------------------*/

WINOLEAUTAPI_(void)
VariantInit(VARIANTARG FAR* pvarg);

WINOLEAUTAPI
VariantClear(VARIANTARG FAR* pvarg);

WINOLEAUTAPI
VariantCopy(
    VARIANTARG FAR* pvargDest,
    VARIANTARG FAR* pvargSrc);

WINOLEAUTAPI
VariantCopyInd(
    VARIANT FAR* pvarDest,
    VARIANTARG FAR* pvargSrc);

WINOLEAUTAPI
VariantChangeType(
    VARIANTARG FAR* pvargDest,
    VARIANTARG FAR* pvarSrc,
    unsigned short wFlags,
    VARTYPE vt);

WINOLEAUTAPI
VariantChangeTypeEx(
    VARIANTARG FAR* pvargDest,
    VARIANTARG FAR* pvarSrc,
    LCID lcid,
    unsigned short wFlags,
    VARTYPE vt);

#define VARIANT_NOVALUEPROP 1

WINOLEAUTAPI_(BSTR) SysAllocString(const OLECHAR FAR*);
WINOLEAUTAPI_(BSTR) SysAllocStringLen(const OLECHAR FAR*, unsigned int);
WINOLEAUTAPI_(void) SysFreeString(BSTR);


// from unknown.h

EXTERN_C const IID IID_NULL;

EXTERN_C const IID IID_IUnknown;

    interface IUnknown
    {
    public:
        virtual HRESULT __stdcall QueryInterface(
            /* [in] */ REFIID riid,
            /* [out] */ void __RPC_FAR *__RPC_FAR *ppvObject) = 0;

        virtual ULONG __stdcall AddRef( void) = 0;

        virtual ULONG __stdcall Release( void) = 0;

#ifdef __TSCPP__
    IUnknown *    GetInterface(REFIID riid);
    IUnknown *    QueryInterface(REFIID riid);
    CLSID &       FindClassID(CLSID &);
    HRESULT       DoQueryInterface(REFIID iid, LPVOID FAR* ppv, REFIID iid2);
#endif
    };

// from objidl.h

    interface ILockBytes : public IUnknown
    {
    public:
        virtual /* [local] */ HRESULT __stdcall ReadAt(
            /* [in] */ ULARGE_INTEGER ulOffset,
            /* [in] */ void __RPC_FAR *pv,
            /* [in] */ ULONG cb,
            /* [out] */ ULONG __RPC_FAR *pcbRead) = 0;

        virtual /* [local] */ HRESULT __stdcall WriteAt(
            /* [in] */ ULARGE_INTEGER ulOffset,
            /* [in] */ const void __RPC_FAR *pv,
            /* [in] */ ULONG cb,
            /* [out] */ ULONG __RPC_FAR *pcbWritten) = 0;

        virtual HRESULT __stdcall Flush( void) = 0;

        virtual HRESULT __stdcall SetSize(
            /* [in] */ ULARGE_INTEGER cb) = 0;

        virtual HRESULT __stdcall LockRegion(
            /* [in] */ ULARGE_INTEGER libOffset,
            /* [in] */ ULARGE_INTEGER cb,
            /* [in] */ DWORD dwLockType) = 0;

        virtual HRESULT __stdcall UnlockRegion(
            /* [in] */ ULARGE_INTEGER libOffset,
            /* [in] */ ULARGE_INTEGER cb,
            /* [in] */ DWORD dwLockType) = 0;

        virtual HRESULT __stdcall Stat(
            /* [out] */ STATSTG __RPC_FAR *pstatstg,
            /* [in] */ DWORD grfStatFlag) = 0;

    };

    interface IMalloc : public IUnknown
    {
    public:
        virtual void __RPC_FAR *__stdcall Alloc(
            /* [in] */ ULONG cb) = 0;

        virtual void __RPC_FAR *__stdcall Realloc(
            /* [in] */ void __RPC_FAR *pv,
            /* [in] */ ULONG cb) = 0;

        virtual void __stdcall Free(
            /* [in] */ void __RPC_FAR *pv) = 0;

        virtual ULONG __stdcall GetSize(
            /* [in] */ void __RPC_FAR *pv) = 0;

        virtual int __stdcall DidAlloc(
            void __RPC_FAR *pv) = 0;

        virtual void __stdcall HeapMinimize( void) = 0;

    };

EXTERN_C const IID IID_IDataObject;

    interface IDataObject : public IUnknown
    {
    public:
        virtual /* [local] */ HRESULT __stdcall GetData(
            /* [unique][in] */ FORMATETC __RPC_FAR *pformatetcIn,
            /* [out] */ STGMEDIUM __RPC_FAR *pmedium) = 0;

        virtual /* [local] */ HRESULT __stdcall GetDataHere(
            /* [unique][in] */ FORMATETC __RPC_FAR *pformatetc,
            /* [out][in] */ STGMEDIUM __RPC_FAR *pmedium) = 0;

        virtual HRESULT __stdcall QueryGetData(
            /* [unique][in] */ FORMATETC __RPC_FAR *pformatetc) = 0;

        virtual HRESULT __stdcall GetCanonicalFormatEtc(
            /* [unique][in] */ FORMATETC __RPC_FAR *pformatectIn,
            /* [out] */ FORMATETC __RPC_FAR *pformatetcOut) = 0;

        virtual /* [local] */ HRESULT __stdcall SetData(
            /* [unique][in] */ FORMATETC __RPC_FAR *pformatetc,
            /* [unique][in] */ STGMEDIUM __RPC_FAR *pmedium,
            /* [in] */ BOOL fRelease) = 0;

        virtual HRESULT __stdcall EnumFormatEtc(
            /* [in] */ DWORD dwDirection,
            /* [out] */ IEnumFORMATETC __RPC_FAR *__RPC_FAR *ppenumFormatEtc) = 0;

        virtual HRESULT __stdcall DAdvise(
            /* [in] */ FORMATETC __RPC_FAR *pformatetc,
            /* [in] */ DWORD advf,
            /* [unique][in] */ IAdviseSink __RPC_FAR *pAdvSink,
            /* [out] */ DWORD __RPC_FAR *pdwConnection) = 0;

        virtual HRESULT __stdcall DUnadvise(
            /* [in] */ DWORD dwConnection) = 0;

        virtual HRESULT __stdcall EnumDAdvise(
            /* [out] */ IEnumSTATDATA __RPC_FAR *__RPC_FAR *ppenumAdvise) = 0;

    };

EXTERN_C const IID IID_IAdviseSink2;
EXTERN_C const IID IID_IAdviseSink;

    interface IAdviseSink : public IUnknown
    {
    public:
        virtual /* [local] */ void __stdcall OnDataChange(
            /* [unique][in] */ FORMATETC __RPC_FAR *pFormatetc,
            /* [unique][in] */ STGMEDIUM __RPC_FAR *pStgmed) = 0;

        virtual /* [local] */ void __stdcall OnViewChange(
            /* [in] */ DWORD dwAspect,
            /* [in] */ LONG lindex) = 0;

        virtual /* [local] */ void __stdcall OnRename(
            /* [in] */ IMoniker __RPC_FAR *pmk) = 0;

        virtual /* [local] */ void __stdcall OnSave( void) = 0;

        virtual /* [local] */ void __stdcall OnClose( void) = 0;

    };

EXTERN_C const IID IID_IStorage;

    interface IStorage : public IUnknown
    {
    public:
        virtual HRESULT __stdcall CreateStream(
            /* [string][in] */ const OLECHAR __RPC_FAR *pwcsName,
            /* [in] */ DWORD grfMode,
            /* [in] */ DWORD reserved1,
            /* [in] */ DWORD reserved2,
            /* [out] */ IStream __RPC_FAR *__RPC_FAR *ppstm) = 0;

        virtual /* [local] */ HRESULT __stdcall OpenStream(
            /* [string][in] */ const OLECHAR __RPC_FAR *pwcsName,
            /* [unique][in] */ void __RPC_FAR *reserved1,
            /* [in] */ DWORD grfMode,
            /* [in] */ DWORD reserved2,
            /* [out] */ IStream __RPC_FAR *__RPC_FAR *ppstm) = 0;

        virtual HRESULT __stdcall CreateStorage(
            /* [string][in] */ const OLECHAR __RPC_FAR *pwcsName,
            /* [in] */ DWORD grfMode,
            /* [in] */ DWORD dwStgFmt,
            /* [in] */ DWORD reserved2,
            /* [out] */ IStorage __RPC_FAR *__RPC_FAR *ppstg) = 0;

        virtual HRESULT __stdcall OpenStorage(
            /* [string][unique][in] */ const OLECHAR __RPC_FAR *pwcsName,
            /* [unique][in] */ IStorage __RPC_FAR *pstgPriority,
            /* [in] */ DWORD grfMode,
            /* [unique][in] */ SNB snbExclude,
            /* [in] */ DWORD reserved,
            /* [out] */ IStorage __RPC_FAR *__RPC_FAR *ppstg) = 0;

        virtual HRESULT __stdcall CopyTo(
            /* [in] */ DWORD ciidExclude,
            /* [size_is][unique][in] */ const IID __RPC_FAR *rgiidExclude,
            /* [unique][in] */ SNB snbExclude,
            /* [unique][in] */ IStorage __RPC_FAR *pstgDest) = 0;

        virtual HRESULT __stdcall MoveElementTo(
            /* [string][in] */ const OLECHAR __RPC_FAR *pwcsName,
            /* [unique][in] */ IStorage __RPC_FAR *pstgDest,
            /* [string][in] */ const OLECHAR __RPC_FAR *pwcsNewName,
            /* [in] */ DWORD grfFlags) = 0;

        virtual HRESULT __stdcall Commit(
            /* [in] */ DWORD grfCommitFlags) = 0;

        virtual HRESULT __stdcall Revert( void) = 0;

        virtual /* [local] */ HRESULT __stdcall EnumElements(
            /* [in] */ DWORD reserved1,
            /* [size_is][unique][in] */ void __RPC_FAR *reserved2,
            /* [in] */ DWORD reserved3,
            /* [out] */ IEnumSTATSTG __RPC_FAR *__RPC_FAR *ppenum) = 0;

        virtual HRESULT __stdcall DestroyElement(
            /* [string][in] */ const OLECHAR __RPC_FAR *pwcsName) = 0;

        virtual HRESULT __stdcall RenameElement(
            /* [string][in] */ const OLECHAR __RPC_FAR *pwcsOldName,
            /* [string][in] */ const OLECHAR __RPC_FAR *pwcsNewName) = 0;

        virtual HRESULT __stdcall SetElementTimes(
            /* [string][in] */ const OLECHAR __RPC_FAR *pwcsName,
            /* [in] */ const FILETIME __RPC_FAR *pctime,
            /* [in] */ const FILETIME __RPC_FAR *patime,
            /* [in] */ const FILETIME __RPC_FAR *pmtime) = 0;

        virtual HRESULT __stdcall SetClass(
            /* [in] */ REFCLSID clsid) = 0;

        virtual HRESULT __stdcall SetStateBits(
            /* [in] */ DWORD grfStateBits,
            /* [in] */ DWORD grfMask) = 0;

        virtual HRESULT __stdcall Stat(
            /* [out] */ STATSTG __RPC_FAR *pstatstg,
            /* [in] */ DWORD grfStatFlag) = 0;

    };

EXTERN_C const IID IID_IPersist;

    interface IPersist : public IUnknown
    {
    public:
        virtual HRESULT __stdcall GetClassID(
            /* [out] */ CLSID __RPC_FAR *pClassID) = 0;

    };

EXTERN_C const IID IID_IPersistStorage;

    interface IPersistStorage : public IPersist
    {
    public:
        virtual HRESULT __stdcall IsDirty( void) = 0;

        virtual HRESULT __stdcall InitNew(
            /* [unique][in] */ IStorage __RPC_FAR *pStg) = 0;

        virtual HRESULT __stdcall Load(
            /* [unique][in] */ IStorage __RPC_FAR *pStg) = 0;

        virtual HRESULT __stdcall Save(
            /* [unique][in] */ IStorage __RPC_FAR *pStgSave,
            /* [in] */ BOOL fSameAsLoad) = 0;

        virtual HRESULT __stdcall SaveCompleted(
            /* [unique][in] */ IStorage __RPC_FAR *pStgNew) = 0;

        virtual HRESULT __stdcall HandsOffStorage( void) = 0;

    };

EXTERN_C const IID IID_IDispatch;

    interface IDispatch : public IUnknown
    {
    public:
        virtual HRESULT __stdcall GetTypeInfoCount(
            /* [out] */ UINT __RPC_FAR *pctinfo) = 0;

        virtual HRESULT __stdcall GetTypeInfo(
            /* [in] */ UINT itinfo,
            /* [in] */ LCID lcid,
            /* [out] */ ITypeInfo __RPC_FAR *__RPC_FAR *pptinfo) = 0;

        virtual HRESULT __stdcall GetIDsOfNames(
            /* [in] */ REFIID riid,
            /* [size_is][in] */ LPOLESTR __RPC_FAR *rgszNames,
            /* [in] */ UINT cNames,
            /* [in] */ LCID lcid,
            /* [size_is][out][in] */ DISPID __RPC_FAR *rgdispid) = 0;

        virtual HRESULT __stdcall Invoke(
            /* [in] */ DISPID dispidMember,
            /* [in] */ REFIID riid,
            /* [in] */ LCID lcid,
            /* [in] */ WORD wFlags,
            /* [unique][in] */ DISPPARAMS __RPC_FAR *pdispparams,
            /* [unique][out][in] */ VARIANT __RPC_FAR *pvarResult,
            /* [out] */ EXCEPINFO __RPC_FAR *pexcepinfo,
            /* [out] */ UINT __RPC_FAR *puArgErr) = 0;

    };

// from oleidl.h

EXTERN_C const IID IID_IEnumFORMATETC;

    interface IEnumFORMATETC : public IUnknown
    {
    public:
        virtual /* [local] */ HRESULT __stdcall Next(
            /* [in] */ ULONG celt,
            /* [out] */ FORMATETC __RPC_FAR *rgelt,
            /* [out] */ ULONG __RPC_FAR *pceltFetched) = 0;

        virtual HRESULT __stdcall Skip(
            /* [in] */ ULONG celt) = 0;

        virtual HRESULT __stdcall Reset( void) = 0;

        virtual HRESULT __stdcall Clone(
            /* [out] */ IEnumFORMATETC __RPC_FAR *__RPC_FAR *ppenum) = 0;

    };

EXTERN_C const IID IID_IParseDisplayName;

    interface IParseDisplayName : public IUnknown
    {
    public:
        virtual HRESULT __stdcall ParseDisplayName(
            /* [unique][in] */ IBindCtx __RPC_FAR *pbc,
            /* [in] */ LPOLESTR pszDisplayName,
            /* [out] */ ULONG __RPC_FAR *pchEaten,
            /* [out] */ IMoniker __RPC_FAR *__RPC_FAR *ppmkOut) = 0;

    };

EXTERN_C const IID IID_IOleContainer;

    interface IOleContainer : public IParseDisplayName
    {
    public:
        virtual HRESULT __stdcall EnumObjects(
            /* [in] */ DWORD grfFlags,
            /* [out] */ IEnumUnknown __RPC_FAR *__RPC_FAR *ppenum) = 0;

        virtual HRESULT __stdcall LockContainer(
            /* [in] */ BOOL fLock) = 0;

    };

EXTERN_C const IID IID_IOleItemContainer;

    interface IOleItemContainer : public IOleContainer
    {
    public:
        virtual /* [local] */ HRESULT __stdcall GetObject(
            /* [in] */ LPOLESTR pszItem,
            /* [in] */ DWORD dwSpeedNeeded,
            /* [unique][in] */ IBindCtx __RPC_FAR *pbc,
            /* [in] */ REFIID riid,
            /* [out] */ void __RPC_FAR *__RPC_FAR *ppvObject) = 0;

        virtual /* [local] */ HRESULT __stdcall GetObjectStorage(
            /* [in] */ LPOLESTR pszItem,
            /* [unique][in] */ IBindCtx __RPC_FAR *pbc,
            /* [in] */ REFIID riid,
            /* [out] */ void __RPC_FAR *__RPC_FAR *ppvStorage) = 0;

        virtual HRESULT __stdcall IsRunning(
            /* [in] */ LPOLESTR pszItem) = 0;

    };

EXTERN_C const IID IID_IOleClientSite;

    interface IOleClientSite : public IUnknown
    {
    public:
        virtual HRESULT __stdcall SaveObject( void) = 0;

        virtual HRESULT __stdcall GetMoniker(
            /* [in] */ DWORD dwAssign,
            /* [in] */ DWORD dwWhichMoniker,
            /* [out] */ IMoniker __RPC_FAR *__RPC_FAR *ppmk) = 0;

        virtual HRESULT __stdcall GetContainer(
            /* [out] */ IOleContainer __RPC_FAR *__RPC_FAR *ppContainer) = 0;

        virtual HRESULT __stdcall ShowObject( void) = 0;

        virtual HRESULT __stdcall OnShowWindow(
            /* [in] */ BOOL fShow) = 0;

        virtual HRESULT __stdcall RequestNewObjectLayout( void) = 0;

    };

EXTERN_C const IID IID_IOleWindow;

    interface IOleWindow : public IUnknown
    {
    public:
        virtual /* [input_sync] */ HRESULT __stdcall GetWindow(
            /* [out] */ HWND __RPC_FAR *phwnd) = 0;

        virtual HRESULT __stdcall ContextSensitiveHelp(
            /* [in] */ BOOL fEnterMode) = 0;

    };

EXTERN_C const IID IID_IOleInPlaceSite;

    interface IOleInPlaceSite : public IOleWindow
    {
    public:
        virtual HRESULT __stdcall CanInPlaceActivate( void) = 0;

        virtual HRESULT __stdcall OnInPlaceActivate( void) = 0;

        virtual HRESULT __stdcall OnUIActivate( void) = 0;

        virtual HRESULT __stdcall GetWindowContext(
            /* [out] */ IOleInPlaceFrame __RPC_FAR *__RPC_FAR *ppFrame,
            /* [out] */ IOleInPlaceUIWindow __RPC_FAR *__RPC_FAR *ppDoc,
            /* [out] */ LPRECT lprcPosRect,
            /* [out] */ LPRECT lprcClipRect,
            /* [out][in] */ LPOLEINPLACEFRAMEINFO lpFrameInfo) = 0;

        virtual HRESULT __stdcall Scroll(
            /* [in] */ SIZE scrollExtant) = 0;

        virtual HRESULT __stdcall OnUIDeactivate(
            /* [in] */ BOOL fUndoable) = 0;

        virtual HRESULT __stdcall OnInPlaceDeactivate( void) = 0;

        virtual HRESULT __stdcall DiscardUndoState( void) = 0;

        virtual HRESULT __stdcall DeactivateAndUndo( void) = 0;

        virtual HRESULT __stdcall OnPosRectChange(
            /* [in] */ LPCRECT lprcPosRect) = 0;

    };

EXTERN_C const IID IID_IOleInPlaceUIWindow;

    interface IOleInPlaceUIWindow : public IOleWindow
    {
    public:
        virtual /* [input_sync] */ HRESULT __stdcall GetBorder(
            /* [out] */ LPRECT lprectBorder) = 0;

        virtual /* [input_sync] */ HRESULT __stdcall RequestBorderSpace(
            /* [unique][in] */ LPCBORDERWIDTHS pborderwidths) = 0;

        virtual /* [input_sync] */ HRESULT __stdcall SetBorderSpace(
            /* [unique][in] */ LPCBORDERWIDTHS pborderwidths) = 0;

        virtual HRESULT __stdcall SetActiveObject(
            /* [unique][in] */ IOleInPlaceActiveObject __RPC_FAR *pActiveObject,
            /* [unique][string][in] */ LPCOLESTR pszObjName) = 0;

    };

EXTERN_C const IID IID_IOleInPlaceFrame;

    interface IOleInPlaceFrame : public IOleInPlaceUIWindow
    {
    public:
        virtual HRESULT __stdcall InsertMenus(
            /* [in] */ HMENU hmenuShared,
            /* [out][in] */ LPOLEMENUGROUPWIDTHS lpMenuWidths) = 0;

        virtual /* [input_sync] */ HRESULT __stdcall SetMenu(
            /* [in] */ HMENU hmenuShared,
            /* [in] */ HOLEMENU holemenu,
            /* [in] */ HWND hwndActiveObject) = 0;

        virtual HRESULT __stdcall RemoveMenus(
            /* [in] */ HMENU hmenuShared) = 0;

        virtual /* [input_sync] */ HRESULT __stdcall SetStatusText(
            /* [in] */ LPCOLESTR pszStatusText) = 0;

        virtual HRESULT __stdcall EnableModeless(
            /* [in] */ BOOL fEnable) = 0;

        virtual HRESULT __stdcall TranslateAccelerator(
            /* [in] */ LPMSG lpmsg,
            /* [in] */ WORD wID) = 0;

    };

EXTERN_C const IID IID_IOleObject;

    interface IOleObject : public IUnknown
    {
    public:
        virtual HRESULT __stdcall SetClientSite(
            /* [unique][in] */ IOleClientSite __RPC_FAR *pClientSite) = 0;

        virtual HRESULT __stdcall GetClientSite(
            /* [out] */ IOleClientSite __RPC_FAR *__RPC_FAR *ppClientSite) = 0;

        virtual HRESULT __stdcall SetHostNames(
            /* [in] */ LPCOLESTR szContainerApp,
            /* [unique][in] */ LPCOLESTR szContainerObj) = 0;

        virtual HRESULT __stdcall Close(
            /* [in] */ DWORD dwSaveOption) = 0;

        virtual HRESULT __stdcall SetMoniker(
            /* [in] */ DWORD dwWhichMoniker,
            /* [unique][in] */ IMoniker __RPC_FAR *pmk) = 0;

        virtual HRESULT __stdcall GetMoniker(
            /* [in] */ DWORD dwAssign,
            /* [in] */ DWORD dwWhichMoniker,
            /* [out] */ IMoniker __RPC_FAR *__RPC_FAR *ppmk) = 0;

        virtual HRESULT __stdcall InitFromData(
            /* [unique][in] */ IDataObject __RPC_FAR *pDataObject,
            /* [in] */ BOOL fCreation,
            /* [in] */ DWORD dwReserved) = 0;

        virtual HRESULT __stdcall GetClipboardData(
            /* [in] */ DWORD dwReserved,
            /* [out] */ IDataObject __RPC_FAR *__RPC_FAR *ppDataObject) = 0;

        virtual HRESULT __stdcall DoVerb(
            /* [in] */ LONG iVerb,
            /* [unique][in] */ LPMSG lpmsg,
            /* [unique][in] */ IOleClientSite __RPC_FAR *pActiveSite,
            /* [in] */ LONG lindex,
            /* [in] */ HWND hwndParent,
            /* [unique][in] */ LPCRECT lprcPosRect) = 0;

        virtual HRESULT __stdcall EnumVerbs(
            /* [out] */ IEnumOLEVERB __RPC_FAR *__RPC_FAR *ppEnumOleVerb) = 0;

        virtual HRESULT __stdcall Update( void) = 0;

        virtual HRESULT __stdcall IsUpToDate( void) = 0;

        virtual HRESULT __stdcall GetUserClassID(
            /* [out] */ CLSID __RPC_FAR *pClsid) = 0;

        virtual HRESULT __stdcall GetUserType(
            /* [in] */ DWORD dwFormOfType,
            /* [out] */ LPOLESTR __RPC_FAR *pszUserType) = 0;

        virtual HRESULT __stdcall SetExtent(
            /* [in] */ DWORD dwDrawAspect,
            /* [in] */ SIZEL __RPC_FAR *psizel) = 0;

        virtual HRESULT __stdcall GetExtent(
            /* [in] */ DWORD dwDrawAspect,
            /* [out] */ SIZEL __RPC_FAR *psizel) = 0;

        virtual HRESULT __stdcall Advise(
            /* [unique][in] */ IAdviseSink __RPC_FAR *pAdvSink,
            /* [out] */ DWORD __RPC_FAR *pdwConnection) = 0;

        virtual HRESULT __stdcall Unadvise(
            /* [in] */ DWORD dwConnection) = 0;

        virtual HRESULT __stdcall EnumAdvise(
            /* [out] */ IEnumSTATDATA __RPC_FAR *__RPC_FAR *ppenumAdvise) = 0;

        virtual HRESULT __stdcall GetMiscStatus(
            /* [in] */ DWORD dwAspect,
            /* [out] */ DWORD __RPC_FAR *pdwStatus) = 0;

        virtual HRESULT __stdcall SetColorScheme(
            /* [in] */ LOGPALETTE __RPC_FAR *pLogpal) = 0;

    };

EXTERN_C const IID IID_IOleInPlaceActiveObject;

    interface IOleInPlaceActiveObject : public IOleWindow
    {
    public:
        virtual /* [local] */ HRESULT __stdcall TranslateAccelerator(
            /* [in] */ LPMSG lpmsg) = 0;

        virtual /* [input_sync] */ HRESULT __stdcall OnFrameWindowActivate(
            /* [in] */ BOOL fActivate) = 0;

        virtual /* [input_sync] */ HRESULT __stdcall OnDocWindowActivate(
            /* [in] */ BOOL fActivate) = 0;

        virtual /* [local] */ HRESULT __stdcall ResizeBorder(
            /* [in] */ LPCRECT prcBorder,
            /* [unique][in] */ IOleInPlaceUIWindow __RPC_FAR *pUIWindow,
            /* [in] */ BOOL fFrameWindow) = 0;

        virtual HRESULT __stdcall EnableModeless(
            /* [in] */ BOOL fEnable) = 0;

    };

EXTERN_C const IID IID_IOleInPlaceObject;

    interface IOleInPlaceObject : public IOleWindow
    {
    public:
        virtual HRESULT __stdcall InPlaceDeactivate( void) = 0;

        virtual HRESULT __stdcall UIDeactivate( void) = 0;

        virtual /* [input_sync] */ HRESULT __stdcall SetObjectRects(
            /* [in] */ LPCRECT lprcPosRect,
            /* [in] */ LPCRECT lprcClipRect) = 0;

        virtual HRESULT __stdcall ReactivateAndUndo( void) = 0;

    };

EXTERN_C const IID IID_IViewObject;

    interface IViewObject : public IUnknown
    {
    public:
        virtual HRESULT __stdcall Draw(
            /* [in] */ DWORD dwDrawAspect,
            /* [in] */ LONG lindex,
            /* [unique][in] */ void __RPC_FAR *pvAspect,
            /* [unique][in] */ DVTARGETDEVICE __RPC_FAR *ptd,
            /* [in] */ HDC hdcTargetDev,
            /* [in] */ HDC hdcDraw,
            /* [in] */ LPCRECTL lprcBounds,
            /* [in] */ LPCRECTL lprcWBounds,
            /* [in] */ BOOL ( __stdcall __RPC_FAR *pfnContinue )(
                DWORD dwContinue),
            /* [in] */ DWORD dwContinue) = 0;

        virtual HRESULT __stdcall GetColorSet(
            /* [in] */ DWORD dwDrawAspect,
            /* [in] */ LONG lindex,
            /* [unique][in] */ void __RPC_FAR *pvAspect,
            /* [in] */ DVTARGETDEVICE __RPC_FAR *ptd,
            /* [in] */ HDC hicTargetDev,
            /* [out] */ LOGPALETTE __RPC_FAR *__RPC_FAR *ppColorSet) = 0;

        virtual HRESULT __stdcall Freeze(
            /* [in] */ DWORD dwDrawAspect,
            /* [in] */ LONG lindex,
            /* [unique][in] */ void __RPC_FAR *pvAspect,
            /* [out] */ DWORD __RPC_FAR *pdwFreeze) = 0;

        virtual HRESULT __stdcall Unfreeze(
            /* [in] */ DWORD dwFreeze) = 0;

        virtual HRESULT __stdcall SetAdvise(
            /* [in] */ DWORD aspects,
            /* [in] */ DWORD advf,
            /* [unique][in] */ IAdviseSink __RPC_FAR *pAdvSink) = 0;

        virtual HRESULT __stdcall GetAdvise(
            /* [out] */ DWORD __RPC_FAR *pAspects,
            /* [out] */ DWORD __RPC_FAR *pAdvf,
            /* [out] */ IAdviseSink __RPC_FAR *__RPC_FAR *ppAdvSink) = 0;

    };

EXTERN_C const IID IID_IViewObject2;

    interface IViewObject2 : public IViewObject
    {
    public:
        virtual HRESULT __stdcall GetExtent(
            /* [in] */ DWORD dwDrawAspect,
            /* [in] */ LONG lindex,
            /* [in] */ DVTARGETDEVICE __RPC_FAR *ptd,
            /* [out] */ LPSIZEL lpsizel) = 0;

    };

EXTERN_C const IID IID_IOleLink;

    interface IOleLink : public IUnknown
    {
    public:
        virtual HRESULT __stdcall SetUpdateOptions(
            /* [in] */ DWORD dwUpdateOpt) = 0;

        virtual HRESULT __stdcall GetUpdateOptions(
            /* [out] */ DWORD __RPC_FAR *pdwUpdateOpt) = 0;

        virtual HRESULT __stdcall SetSourceMoniker(
            /* [unique][in] */ IMoniker __RPC_FAR *pmk,
            /* [in] */ REFCLSID rclsid) = 0;

        virtual HRESULT __stdcall GetSourceMoniker(
            /* [out] */ IMoniker __RPC_FAR *__RPC_FAR *ppmk) = 0;

        virtual HRESULT __stdcall SetSourceDisplayName(
            /* [in] */ LPCOLESTR pszStatusText) = 0;

        virtual HRESULT __stdcall GetSourceDisplayName(
            /* [out] */ LPOLESTR __RPC_FAR *ppszDisplayName) = 0;

        virtual HRESULT __stdcall BindToSource(
            /* [in] */ DWORD bindflags,
            /* [unique][in] */ IBindCtx __RPC_FAR *pbc) = 0;

        virtual HRESULT __stdcall BindIfRunning( void) = 0;

        virtual HRESULT __stdcall GetBoundSource(
            /* [out] */ IUnknown __RPC_FAR *__RPC_FAR *ppunk) = 0;

        virtual HRESULT __stdcall UnbindSource( void) = 0;

        virtual HRESULT __stdcall Update(
            /* [unique][in] */ IBindCtx __RPC_FAR *pbc) = 0;

    };

EXTERN_C const IID IID_IStream;

    interface IStream : public IUnknown
    {
    public:
        virtual /* [local] */ HRESULT __stdcall Read(
            /* [out] */ void __RPC_FAR *pv,
            /* [in] */ ULONG cb,
            /* [out] */ ULONG __RPC_FAR *pcbRead) = 0;

        virtual /* [local] */ HRESULT __stdcall Write(
            /* [size_is][in] */ const void __RPC_FAR *pv,
            /* [in] */ ULONG cb,
            /* [out] */ ULONG __RPC_FAR *pcbWritten) = 0;

        virtual /* [local] */ HRESULT __stdcall Seek(
            /* [in] */ LARGE_INTEGER dlibMove,
            /* [in] */ DWORD dwOrigin,
            /* [out] */ ULARGE_INTEGER __RPC_FAR *plibNewPosition) = 0;
        
        virtual HRESULT __stdcall SetSize(
            /* [in] */ ULARGE_INTEGER libNewSize) = 0;
        
        virtual /* [local] */ HRESULT __stdcall CopyTo(
            /* [unique][in] */ IStream __RPC_FAR *pstm,
            /* [in] */ ULARGE_INTEGER cb,
            /* [out] */ ULARGE_INTEGER __RPC_FAR *pcbRead,
            /* [out] */ ULARGE_INTEGER __RPC_FAR *pcbWritten) = 0;

        virtual HRESULT __stdcall Commit(
            /* [in] */ DWORD grfCommitFlags) = 0;

        virtual HRESULT __stdcall Revert( void) = 0;
        
        virtual HRESULT __stdcall LockRegion( 
            /* [in] */ ULARGE_INTEGER libOffset,
            /* [in] */ ULARGE_INTEGER cb,
            /* [in] */ DWORD dwLockType) = 0;
        
        virtual HRESULT __stdcall UnlockRegion( 
            /* [in] */ ULARGE_INTEGER libOffset,
            /* [in] */ ULARGE_INTEGER cb,
            /* [in] */ DWORD dwLockType) = 0;
        
        virtual HRESULT __stdcall Stat(
            /* [out] */ STATSTG __RPC_FAR *pstatstg,
            /* [in] */ DWORD grfStatFlag) = 0;

        virtual HRESULT __stdcall Clone(
            /* [out] */ IStream __RPC_FAR *__RPC_FAR *ppstm) = 0;

    };

EXTERN_C const IID IID_IPersistStream;

    interface IPersistStream : public IPersist
    {
    public:
        virtual HRESULT __stdcall IsDirty( void) = 0;

        virtual HRESULT __stdcall Load(
            /* [unique][in] */ IStream __RPC_FAR *pStm) = 0;

        virtual HRESULT __stdcall Save(
            /* [unique][in] */ IStream __RPC_FAR *pStm,
            /* [in] */ BOOL fClearDirty) = 0;

        virtual HRESULT __stdcall GetSizeMax(
            /* [out] */ ULARGE_INTEGER __RPC_FAR *pcbSize) = 0;

    };

EXTERN_C const IID IID_IMoniker;

    interface IMoniker : public IPersistStream
    {
    public:
        virtual /* [local] */ HRESULT __stdcall BindToObject(
            /* [unique][in] */ IBindCtx __RPC_FAR *pbc,
            /* [unique][in] */ IMoniker __RPC_FAR *pmkToLeft,
            /* [in] */ REFIID riidResult,
            /* [out] */ void __RPC_FAR *__RPC_FAR *ppvResult) = 0;

        virtual /* [local] */ HRESULT __stdcall BindToStorage(
            /* [unique][in] */ IBindCtx __RPC_FAR *pbc,
            /* [unique][in] */ IMoniker __RPC_FAR *pmkToLeft,
            /* [in] */ REFIID riid,
            /* [out] */ void __RPC_FAR *__RPC_FAR *ppvObj) = 0;

        virtual HRESULT __stdcall Reduce(
            /* [unique][in] */ IBindCtx __RPC_FAR *pbc,
            /* [in] */ DWORD dwReduceHowFar,
            /* [unique][out][in] */ IMoniker __RPC_FAR *__RPC_FAR *ppmkToLeft,
            /* [out] */ IMoniker __RPC_FAR *__RPC_FAR *ppmkReduced) = 0;

        virtual HRESULT __stdcall ComposeWith(
            /* [unique][in] */ IMoniker __RPC_FAR *pmkRight,
            /* [in] */ BOOL fOnlyIfNotGeneric,
            /* [out] */ IMoniker __RPC_FAR *__RPC_FAR *ppmkComposite) = 0;

        virtual HRESULT __stdcall Enum(
            /* [in] */ BOOL fForward,
            /* [out] */ IEnumMoniker __RPC_FAR *__RPC_FAR *ppenumMoniker) = 0;

        virtual HRESULT __stdcall IsEqual(
            /* [unique][in] */ IMoniker __RPC_FAR *pmkOtherMoniker) = 0;

        virtual HRESULT __stdcall Hash(
            /* [out] */ DWORD __RPC_FAR *pdwHash) = 0;

        virtual HRESULT __stdcall IsRunning(
            /* [unique][in] */ IBindCtx __RPC_FAR *pbc,
            /* [unique][in] */ IMoniker __RPC_FAR *pmkToLeft,
            /* [unique][in] */ IMoniker __RPC_FAR *pmkNewlyRunning) = 0;

        virtual HRESULT __stdcall GetTimeOfLastChange(
            /* [unique][in] */ IBindCtx __RPC_FAR *pbc,
            /* [unique][in] */ IMoniker __RPC_FAR *pmkToLeft,
            /* [out] */ FILETIME __RPC_FAR *pFileTime) = 0;

        virtual HRESULT __stdcall Inverse(
            /* [out] */ IMoniker __RPC_FAR *__RPC_FAR *ppmk) = 0;

        virtual HRESULT __stdcall CommonPrefixWith(
            /* [unique][in] */ IMoniker __RPC_FAR *pmkOther,
            /* [out] */ IMoniker __RPC_FAR *__RPC_FAR *ppmkPrefix) = 0;

        virtual HRESULT __stdcall RelativePathTo(
            /* [unique][in] */ IMoniker __RPC_FAR *pmkOther,
            /* [out] */ IMoniker __RPC_FAR *__RPC_FAR *ppmkRelPath) = 0;

        virtual HRESULT __stdcall GetDisplayName(
            /* [unique][in] */ IBindCtx __RPC_FAR *pbc,
            /* [unique][in] */ IMoniker __RPC_FAR *pmkToLeft,
            /* [out] */ LPOLESTR __RPC_FAR *ppszDisplayName) = 0;

        virtual HRESULT __stdcall ParseDisplayName(
            /* [unique][in] */ IBindCtx __RPC_FAR *pbc,
            /* [unique][in] */ IMoniker __RPC_FAR *pmkToLeft,
            /* [in] */ LPOLESTR pszDisplayName,
            /* [out] */ ULONG __RPC_FAR *pchEaten,
            /* [out] */ IMoniker __RPC_FAR *__RPC_FAR *ppmkOut) = 0;

        virtual HRESULT __stdcall IsSystemMoniker(
            /* [out] */ DWORD __RPC_FAR *pdwMksys) = 0;

    };

EXTERN_C const IID IID_IOleControl;

    interface IOleControl : public IUnknown
    {
	// IUnknown methods
	STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
	STDMETHOD_(ULONG,AddRef)(THIS) PURE;
	STDMETHOD_(ULONG,Release)(THIS) PURE;

	// IOleControl methods
	STDMETHOD(GetControlInfo)(THIS_ LPCONTROLINFO pCI) PURE;
	STDMETHOD(OnMnemonic)(THIS_ LPMSG pMsg) PURE;
	STDMETHOD(OnAmbientPropertyChange)(THIS_ DISPID dispid) PURE;
	STDMETHOD(FreezeEvents)(THIS_ BOOL bFreeze) PURE;
    };


EXTERN_C const IID IID_IOleControlSite;

    interface IOleControlSite : public IUnknown
    {
	// IUnknown methods
	STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
	STDMETHOD_(ULONG,AddRef)(THIS) PURE;
	STDMETHOD_(ULONG,Release)(THIS) PURE;

	// IOleControlSite methods
	STDMETHOD(OnControlInfoChanged)(THIS) PURE;
	STDMETHOD(LockInPlaceActive)(THIS_ BOOL fLock) PURE;
	STDMETHOD(GetExtendedControl)(THIS_ LPDISPATCH FAR* ppDisp) PURE;
	STDMETHOD(TransformCoords)(THIS_ POINTL FAR* lpptlHimetric,
		POINTF FAR* lpptfContainer, DWORD flags) PURE;
	STDMETHOD(TranslateAccelerator)(THIS_ LPMSG lpMsg, DWORD grfModifiers)
		PURE;
	STDMETHOD(OnFocus)(THIS_ BOOL fGotFocus) PURE;
	STDMETHOD(ShowPropertyFrame)(THIS) PURE;
    };

#define XFORMCOORDS_POSITION            0x1
#define XFORMCOORDS_SIZE                0x2
#define XFORMCOORDS_HIMETRICTOCONTAINER 0x4
#define XFORMCOORDS_CONTAINERTOHIMETRIC 0x8

EXTERN_C const IID IID_IConnectionPointContainer;

    interface IConnectionPointContainer : public IUnknown
    {
	// IUnknown methods
	STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
	STDMETHOD_(ULONG,AddRef)(THIS) PURE;
	STDMETHOD_(ULONG,Release)(THIS) PURE;

	// IConnectionPointContainer methods
	STDMETHOD(EnumConnectionPoints)(THIS_ LPENUMCONNECTIONPOINTS FAR* ppEnum)
		PURE;
	STDMETHOD(FindConnectionPoint)(THIS_ REFIID iid,
		LPCONNECTIONPOINT FAR* ppCP) PURE;
    };


EXTERN_C const IID IID_IConnectionPoint;

    interface IConnectionPoint : public IUnknown
    {
	// IUnknown methods
	STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
	STDMETHOD_(ULONG,AddRef)(THIS) PURE;
	STDMETHOD_(ULONG,Release)(THIS) PURE;

	// IConnectionPoint methods
	STDMETHOD(GetConnectionInterface)(THIS_ IID FAR* pIID) PURE;
	STDMETHOD(GetConnectionPointContainer)(THIS_
		IConnectionPointContainer FAR* FAR* ppCPC) PURE;
	STDMETHOD(Advise)(THIS_ LPUNKNOWN pUnkSink, DWORD FAR* pdwCookie) PURE;
	STDMETHOD(Unadvise)(THIS_ DWORD dwCookie) PURE;
	STDMETHOD(EnumConnections)(THIS_ LPENUMCONNECTIONS FAR* ppEnum) PURE;
    };

EXTERN_C const IID IID_IProvideClassInfo;

    interface IProvideClassInfo : public IUnknown
    {
	// IUnknown methods
	STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
	STDMETHOD_(ULONG,AddRef)(THIS) PURE;
	STDMETHOD_(ULONG,Release)(THIS) PURE;

	// IProvideClassInfo methods
	STDMETHOD(GetClassInfo)(THIS_ LPTYPEINFO FAR* ppTI) PURE;
    };

EXTERN_C const IID IID_ITypeInfo;

    interface ITypeInfo : public IUnknown
    {
    public:
        virtual HRESULT __stdcall GetTypeAttr(
            /* [out] */ TYPEATTR __RPC_FAR *__RPC_FAR *pptypeattr) = 0;

        virtual HRESULT __stdcall GetTypeComp(
            /* [out] */ struct ITypeComp __RPC_FAR *__RPC_FAR *pptcomp) = 0;

        virtual HRESULT __stdcall GetFuncDesc(
            /* [in] */ UINT index,
            /* [out] */ struct FUNCDESC __RPC_FAR *__RPC_FAR *pppfuncdesc) = 0;

        virtual HRESULT __stdcall GetVarDesc(
            /* [in] */ UINT index,
            /* [out] */ VARDESC __RPC_FAR *__RPC_FAR *ppvardesc) = 0;

        virtual HRESULT __stdcall GetNames(
            /* [in] */ MEMBERID memid,
            /* [length_is][size_is][out] */ BSTR __RPC_FAR *rgbstrNames,
            /* [in] */ UINT cMaxNames,
            /* [out] */ UINT __RPC_FAR *pcNames) = 0;

        virtual HRESULT __stdcall GetRefTypeOfImplType(
            /* [in] */ UINT index,
            /* [out] */ HREFTYPE __RPC_FAR *hpreftype) = 0;

        virtual HRESULT __stdcall GetImplTypeFlags(
            /* [in] */ UINT index,
            /* [out] */ int __RPC_FAR *pimpltypeflags) = 0;

        virtual HRESULT __stdcall GetIDsOfNames(
            /* [size_is][in] */ OLECHAR __RPC_FAR *__RPC_FAR *rglpszNames,
            /* [in] */ UINT cNames,
            /* [size_is][out] */ MEMBERID __RPC_FAR *rgmemid) = 0;

        virtual HRESULT __stdcall Invoke(
            /* [unique][in] */ void __RPC_FAR *pvInstance,
            /* [in] */ MEMBERID memid,
            /* [in] */ WORD wFlags,
            /* [in] */ DISPPARAMS __RPC_FAR *pdispparams,
            /* [out] */ VARIANT __RPC_FAR *pvarResult,
            /* [out] */ EXCEPINFO __RPC_FAR *pexcepinfo,
            /* [out] */ UINT __RPC_FAR *puArgErr) = 0;

        virtual HRESULT __stdcall GetDocumentation(
            /* [in] */ MEMBERID memid,
            /* [out] */ BSTR __RPC_FAR *pbstrName,
            /* [out] */ BSTR __RPC_FAR *pbstrDocString,
            /* [out] */ DWORD __RPC_FAR *pdwHelpContext,
            /* [out] */ BSTR __RPC_FAR *pbstrHelpFile) = 0;

        virtual HRESULT __stdcall GetDllEntry(
            /* [in] */ MEMBERID memid,
            /* [in] */ INVOKEKIND invkind,
            /* [out] */ BSTR __RPC_FAR *pbstrDllName,
            /* [out] */ BSTR __RPC_FAR *pbstrName,
            /* [out] */ WORD __RPC_FAR *pwOrdinal) = 0;

        virtual HRESULT __stdcall GetRefTypeInfo(
            /* [in] */ HREFTYPE hreftype,
            /* [out] */ ITypeInfo __RPC_FAR *__RPC_FAR *pptinfo) = 0;

        virtual HRESULT __stdcall AddressOfMember(
            /* [in] */ MEMBERID memid,
            /* [in] */ INVOKEKIND invkind,
            /* [out] */ void __RPC_FAR *__RPC_FAR *ppv) = 0;

        virtual HRESULT __stdcall CreateInstance(
            /* [in] */ IUnknown __RPC_FAR *puncOuter,
            /* [in] */ REFIID riid,
            /* [out] */ void __RPC_FAR *__RPC_FAR *ppvObj) = 0;

        virtual HRESULT __stdcall GetMops(
            /* [in] */ MEMBERID memid,
            /* [out] */ BSTR __RPC_FAR *pbstrMops) = 0;

        virtual HRESULT __stdcall GetContainingTypeLib(
            /* [out] */ struct ITypeLib __RPC_FAR *__RPC_FAR *pptlib,
            /* [out] */ UINT __RPC_FAR *pindex) = 0;

        virtual void __stdcall ReleaseTypeAttr(
            /* [in] */ TYPEATTR __RPC_FAR *ptypeattr) = 0;

        virtual void __stdcall ReleaseFuncDesc(
            /* [in] */ struct FUNCDESC __RPC_FAR *pfuncdesc) = 0;

        virtual void __stdcall ReleaseVarDesc(
            /* [in] */ VARDESC __RPC_FAR *pvardesc) = 0;

    };

EXTERN_C const IID IID_IPropertyNotifySink;

    interface IPropertyNotifySink : public IUnknown
{
	// IUnknown methods
	STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
	STDMETHOD_(ULONG,AddRef)(THIS) PURE;
	STDMETHOD_(ULONG,Release)(THIS) PURE;

	// IPropertyNotifySink methods
	STDMETHOD(OnChanged)(THIS_ DISPID dispid) PURE;
	STDMETHOD(OnRequestEdit)(THIS_ DISPID dispid) PURE;
};

typedef IClassFactory __RPC_FAR *LPCLASSFACTORY;

    interface IClassFactory : public IUnknown
{
    public:
        virtual /* [local] */ HRESULT __stdcall CreateInstance(
            /* [unique][in] */ IUnknown __RPC_FAR *pUnkOuter,
            /* [in] */ REFIID riid,
            /* [out] */ void __RPC_FAR *__RPC_FAR *ppvObject) = 0;

        virtual HRESULT __stdcall LockServer(
            /* [in] */ BOOL fLock) = 0;

    };

// IClassFactory2 interface

interface IClassFactory2 : public IClassFactory
{
	// IUnknown methods
	STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
	STDMETHOD_(ULONG,AddRef)(THIS) PURE;
	STDMETHOD_(ULONG,Release)(THIS) PURE;

	// IClassFactory methods
	STDMETHOD(CreateInstance)(THIS_ LPUNKNOWN pUnkOuter, REFIID riid,
		LPVOID FAR* ppvObject) PURE;
	STDMETHOD(LockServer)(THIS_ BOOL fLock) PURE;

	//  IClassFactory2 methods
	STDMETHOD(GetLicInfo)(THIS_ LPLICINFO pLicInfo) PURE;
	STDMETHOD(RequestLicKey)(THIS_ DWORD dwResrved, BSTR FAR* pbstrKey) PURE;
	STDMETHOD(CreateInstanceLic)(THIS_ LPUNKNOWN pUnkOuter,
		LPUNKNOWN pUnkReserved, REFIID riid, BSTR bstrKey,
		LPVOID FAR* ppvObject) PURE;
};

enum DESCKIND
    {	DESCKIND_NONE	= 0,
	DESCKIND_FUNCDESC	= DESCKIND_NONE + 1,
	DESCKIND_VARDESC	= DESCKIND_FUNCDESC + 1,
	DESCKIND_TYPECOMP	= DESCKIND_VARDESC + 1,
	DESCKIND_IMPLICITAPPOBJ	= DESCKIND_TYPECOMP + 1,
	DESCKIND_MAX	= DESCKIND_IMPLICITAPPOBJ + 1
    };

typedef struct  tagELEMDESC
    {
    TYPEDESC tdesc;
    IDLDESC idldesc;
    }	ELEMDESC;

enum VARKIND
    {	VAR_PERINSTANCE	= 0,
	VAR_STATIC	= VAR_PERINSTANCE + 1,
	VAR_CONST	= VAR_STATIC + 1,
	VAR_DISPATCH	= VAR_CONST + 1
    };

struct  VARDESC
    {
    MEMBERID memid;
    LPOLESTR lpstrSchema;
    /* [switch_is][switch_type] */ union
        {
        /* [case] */ ULONG oInst;
        /* [case] */ VARIANT __RPC_FAR *lpvarValue;
        }	;
    ELEMDESC elemdescVar;
    WORD wVarFlags;
    VARKIND varkind;
    };

union BINDPTR
    {
       struct FUNCDESC *lpfuncdesc;
       VARDESC *lpvardesc;
       ITypeComp *lptcomp;
    };

EXTERN_C const IID IID_ITypeComp;

    interface ITypeComp : public IUnknown
    {
    public:
        virtual HRESULT __stdcall Bind(
            /* [in] */ LPOLESTR szName,
            /* [in] */ ULONG lHashVal,
            /* [in] */ WORD fFlags,
            /* [out] */ ITypeInfo __RPC_FAR *__RPC_FAR *pptinfo,
            /* [out] */ DESCKIND __RPC_FAR *pdesckind,
            /* [switch_is][out] */ BINDPTR __RPC_FAR *pbindptr) = 0;

        virtual HRESULT __stdcall BindType(
            /* [in] */ LPOLESTR szName,
            /* [in] */ ULONG lHashVal,
            /* [out] */ ITypeInfo __RPC_FAR *__RPC_FAR *pptinfo,
            /* [out] */ ITypeComp __RPC_FAR *__RPC_FAR *pptcomp) = 0;

    };

// From OBJBASE.H

WINOLEAPI  CoGetClassObject(REFCLSID rclsid, DWORD dwClsContext, LPVOID pvReserved,
                    REFIID riid, LPVOID FAR* ppv);
WINOLEAPI  CoDisconnectObject(LPUNKNOWN pUnk, DWORD dwReserved);
WINOLEAPI  CoGetMalloc(DWORD dwMemContext, LPMALLOC FAR* ppMalloc);
WINOLEAPI  StringFromCLSID(REFCLSID rclsid, LPOLESTR FAR* lplpsz);
WINOLEAPI  StringFromIID(REFIID rclsid, LPOLESTR FAR* lplpsz);
WINOLEAPI  CLSIDFromString(LPOLESTR lpsz, LPCLSID pclsid);
WINOLEAPI_(BOOL) CoIsOle1Class(REFCLSID rclsid);
WINOLEAPI  ProgIDFromCLSID (REFCLSID clsid, LPOLESTR FAR* lplpszProgID);
WINOLEAPI  IIDFromString(LPOLESTR lpsz, LPIID lpiid);
WINOLEAPI  CLSIDFromProgID (LPCOLESTR lpszProgID, LPCLSID lpclsid);
WINOLEAPI  CreateItemMoniker(LPCOLESTR lpszDelim, LPCOLESTR lpszItem,
    LPMONIKER FAR* ppmk);
WINOLEAPI  CreateGenericComposite(LPMONIKER pmkFirst, LPMONIKER pmkRest,
    LPMONIKER FAR* ppmkComposite);
WINOLEAPI  GetClassFile (LPCOLESTR szFilename, CLSID FAR* pclsid);
WINOLEAPI_(int) StringFromGUID2(REFGUID rguid, LPOLESTR lpsz, int cbMax);

inline BOOL operator==(const GUID& guidOne, const GUID& guidOther)
{
    return !memcmp(&guidOne,&guidOther,sizeof(GUID));
}

inline BOOL operator!=(const GUID& guidOne, const GUID& guidOther)
{
    return !(guidOne == guidOther);
}

// From OLE2.H

#pragma save, data(pack=>8)

// View OBJECT Error Codes

#define E_DRAW                  VIEW_E_DRAW

// IDataObject Error Codes
#define DATA_E_FORMATETC        DV_E_FORMATETC





// Common stuff gleamed from OLE.2,

/* verbs */
#define OLEIVERB_PRIMARY            (0L)
#define OLEIVERB_SHOW               (-1L)
#define OLEIVERB_OPEN               (-2L)
#define OLEIVERB_HIDE               (-3L)
#define OLEIVERB_UIACTIVATE         (-4L)
#define OLEIVERB_INPLACEACTIVATE    (-5L)
#define OLEIVERB_DISCARDUNDOSTATE   (-6L)

// for OleCreateEmbeddingHelper flags; roles in low word; options in high word
#define EMBDHLP_INPROC_HANDLER   0x0000L
#define EMBDHLP_INPROC_SERVER    0x0001L
#define EMBDHLP_CREATENOW    0x00000000L
#define EMBDHLP_DELAYCREATE  0x00010000L

/****** DV APIs ***********************************************************/


///// WINOLEAPI CreateDataAdviseHolder(LPDATAADVISEHOLDER FAR* ppDAHolder);







/****** OLE API Prototypes ************************************************/

WINOLEAPI_(DWORD) OleBuildVersion( VOID );

/* helper functions */
WINOLEAPI ReadClassStg(LPSTORAGE pStg, CLSID FAR* pclsid);
WINOLEAPI WriteClassStg(LPSTORAGE pStg, REFCLSID rclsid);
WINOLEAPI ReadClassStm(LPSTREAM pStm, CLSID FAR* pclsid);
WINOLEAPI WriteClassStm(LPSTREAM pStm, REFCLSID rclsid);
WINOLEAPI WriteFmtUserTypeStg (LPSTORAGE pstg, CLIPFORMAT cf, LPOLESTR lpszUserType);
WINOLEAPI ReadFmtUserTypeStg (LPSTORAGE pstg, CLIPFORMAT FAR* pcf, LPOLESTR FAR* lplpszUserType);


/* init/term */

WINOLEAPI OleInitialize(LPVOID pvReserved);
WINOLEAPI_(void) OleUninitialize(void);

WINOLEAPI  CoInitialize(LPVOID pvReserved);
WINOLEAPI_(void)  CoUninitialize(void);


/* APIs to query whether (Embedded/Linked) object can be created from
   the data object */

WINOLEAPI  OleQueryLinkFromData(LPDATAOBJECT pSrcDataObject);
WINOLEAPI  OleQueryCreateFromData(LPDATAOBJECT pSrcDataObject);


/* Object creation APIs */

WINOLEAPI  OleCreate(REFCLSID rclsid, REFIID riid, DWORD renderopt,
                LPFORMATETC pFormatEtc, LPOLECLIENTSITE pClientSite,
                LPSTORAGE pStg, LPVOID FAR* ppvObj);

WINOLEAPI  OleCreateFromData(LPDATAOBJECT pSrcDataObj, REFIID riid,
                DWORD renderopt, LPFORMATETC pFormatEtc,
                LPOLECLIENTSITE pClientSite, LPSTORAGE pStg,
                LPVOID FAR* ppvObj);

WINOLEAPI  OleCreateLinkFromData(LPDATAOBJECT pSrcDataObj, REFIID riid,
                DWORD renderopt, LPFORMATETC pFormatEtc,
                LPOLECLIENTSITE pClientSite, LPSTORAGE pStg,
                LPVOID FAR* ppvObj);

WINOLEAPI  OleCreateStaticFromData(LPDATAOBJECT pSrcDataObj, REFIID iid,
                DWORD renderopt, LPFORMATETC pFormatEtc,
                LPOLECLIENTSITE pClientSite, LPSTORAGE pStg,
                LPVOID FAR* ppvObj);


WINOLEAPI  OleCreateLink(LPMONIKER pmkLinkSrc, REFIID riid,
            DWORD renderopt, LPFORMATETC lpFormatEtc,
            LPOLECLIENTSITE pClientSite, LPSTORAGE pStg, LPVOID FAR* ppvObj);

WINOLEAPI  OleCreateLinkToFile(LPCOLESTR lpszFileName, REFIID riid,
            DWORD renderopt, LPFORMATETC lpFormatEtc,
            LPOLECLIENTSITE pClientSite, LPSTORAGE pStg, LPVOID FAR* ppvObj);

WINOLEAPI  OleCreateFromFile(REFCLSID rclsid, LPCOLESTR lpszFileName, REFIID riid,
            DWORD renderopt, LPFORMATETC lpFormatEtc,
            LPOLECLIENTSITE pClientSite, LPSTORAGE pStg, LPVOID FAR* ppvObj);

WINOLEAPI  OleLoad(LPSTORAGE pStg, REFIID riid, LPOLECLIENTSITE pClientSite,
            LPVOID FAR* ppvObj);

WINOLEAPI  OleSave(LPPERSISTSTORAGE pPS, LPSTORAGE pStg, BOOL fSameAsLoad);

WINOLEAPI  OleLoadFromStream( LPSTREAM pStm, REFIID iidInterface, LPVOID FAR* ppvObj);
WINOLEAPI  OleSaveToStream( LPPERSISTSTREAM pPStm, LPSTREAM pStm );


WINOLEAPI  OleSetContainedObject(LPUNKNOWN pUnknown, BOOL fContained);
WINOLEAPI  OleNoteObjectVisible(LPUNKNOWN pUnknown, BOOL fVisible);


/* Drag/Drop APIs */

WINOLEAPI  RegisterDragDrop(HWND hwnd, LPDROPTARGET pDropTarget);
WINOLEAPI  RevokeDragDrop(HWND hwnd);
WINOLEAPI  DoDragDrop(LPDATAOBJECT pDataObj, LPDROPSOURCE pDropSource,
            DWORD dwOKEffects, LPDWORD pdwEffect);

/* Clipboard APIs */

WINOLEAPI  OleSetClipboard(LPDATAOBJECT pDataObj);
WINOLEAPI  OleGetClipboard(LPDATAOBJECT FAR* ppDataObj);
WINOLEAPI  OleFlushClipboard(void);
WINOLEAPI  OleIsCurrentClipboard(LPDATAOBJECT pDataObj);


/* InPlace Editing APIs */

WINOLEAPI_(HOLEMENU)   OleCreateMenuDescriptor (HMENU hmenuCombined,
                                LPOLEMENUGROUPWIDTHS lpMenuWidths);
WINOLEAPI              OleSetMenuDescriptor (HOLEMENU holemenu, HWND hwndFrame,
                                HWND hwndActiveObject,
                                LPOLEINPLACEFRAME lpFrame,
                                LPOLEINPLACEACTIVEOBJECT lpActiveObj);
WINOLEAPI              OleDestroyMenuDescriptor (HOLEMENU holemenu);

WINOLEAPI              OleTranslateAccelerator (LPOLEINPLACEFRAME lpFrame,
                            LPOLEINPLACEFRAMEINFO lpFrameInfo, LPMSG lpmsg);


/* Helper APIs */
WINOLEAPI_(HANDLE) OleDuplicateData (HANDLE hSrc, CLIPFORMAT cfFormat,
                        UINT uiFlags);

WINOLEAPI          OleDraw (LPUNKNOWN pUnknown, DWORD dwAspect, HDC hdcDraw,
                    LPCRECT lprcBounds);

WINOLEAPI          OleRun(LPUNKNOWN pUnknown);
WINOLEAPI_(BOOL)   OleIsRunning(LPOLEOBJECT pObject);
WINOLEAPI          OleLockRunning(LPUNKNOWN pUnknown, BOOL fLock, BOOL fLastUnlockCloses);
WINOLEAPI_(void)   ReleaseStgMedium(LPSTGMEDIUM);
WINOLEAPI          CreateOleAdviseHolder(LPOLEADVISEHOLDER FAR* ppOAHolder);

WINOLEAPI          OleCreateDefaultHandler(REFCLSID clsid, LPUNKNOWN pUnkOuter,
                    REFIID riid, LPVOID FAR* lplpObj);

WINOLEAPI          OleCreateEmbeddingHelper(REFCLSID clsid, LPUNKNOWN pUnkOuter,
                    DWORD flags, LPCLASSFACTORY pCF,
                                        REFIID riid, LPVOID FAR* lplpObj);

WINOLEAPI_(BOOL)   IsAccelerator(HACCEL hAccel, int cAccelEntries, LPMSG lpMsg,
                                        WORD FAR* lpwCmd);
/* Icon extraction Helper APIs */

WINOLEAPI_(HGLOBAL) OleGetIconOfFile(LPOLESTR lpszPath, BOOL fUseFileAsLabel);

WINOLEAPI_(HGLOBAL) OleGetIconOfClass(REFCLSID rclsid,     LPOLESTR lpszLabel,
                                        BOOL fUseTypeAsLabel);

WINOLEAPI_(HGLOBAL) OleMetafilePictFromIconAndLabel(HICON hIcon, LPOLESTR lpszLabel,
                                        LPOLESTR lpszSourceFile, UINT iIconIndex);



/* Registration Database Helper APIs */

WINOLEAPI                  OleRegGetUserType (REFCLSID clsid, DWORD dwFormOfType,
                                        LPOLESTR FAR* pszUserType);

WINOLEAPI                  OleRegGetMiscStatus     (REFCLSID clsid, DWORD dwAspect,
                                        DWORD FAR* pdwStatus);

WINOLEAPI                  OleRegEnumFormatEtc     (REFCLSID clsid, DWORD dwDirection,
                                        LPENUMFORMATETC FAR* ppenum);

WINOLEAPI                  OleRegEnumVerbs (REFCLSID clsid, LPENUMOLEVERB FAR* ppenum);



STDAPI OleCreatePictureIndirect(PICTDESC FAR *lpPictDesc, REFIID riid, BOOL fOwn,
	LPVOID FAR* lplpvObj);



/* OLE 1.0 conversion APIS */

/***** OLE 1.0 OLESTREAM declarations *************************************/

typedef struct _OLESTREAM FAR*  LPOLESTREAM;

typedef struct _OLESTREAMVTBL
{
    DWORD (CALLBACK* Get)(LPOLESTREAM, void FAR*, DWORD);
    DWORD (CALLBACK* Put)(LPOLESTREAM, const void FAR*, DWORD);
} OLESTREAMVTBL;
typedef  OLESTREAMVTBL FAR*  LPOLESTREAMVTBL;

typedef struct _OLESTREAM
{
    LPOLESTREAMVTBL lpstbl;
} OLESTREAM;


WINOLEAPI OleConvertOLESTREAMToIStorage
    (LPOLESTREAM                lpolestream,
    LPSTORAGE                   pstg,
    const DVTARGETDEVICE FAR*   ptd);

WINOLEAPI OleConvertIStorageToOLESTREAM
    (LPSTORAGE      pstg,
    LPOLESTREAM     lpolestream);


/* Storage Utility APIs */
WINOLEAPI GetHGlobalFromILockBytes (LPLOCKBYTES plkbyt, HGLOBAL FAR* phglobal);
WINOLEAPI CreateILockBytesOnHGlobal (HGLOBAL hGlobal, BOOL fDeleteOnRelease,
                                    LPLOCKBYTES FAR* pplkbyt);

WINOLEAPI GetHGlobalFromStream (LPSTREAM pstm, HGLOBAL FAR* phglobal);
WINOLEAPI CreateStreamOnHGlobal (HGLOBAL hGlobal, BOOL fDeleteOnRelease,
                                LPSTREAM FAR* ppstm);


/* ConvertTo APIS */

WINOLEAPI OleDoAutoConvert(LPSTORAGE pStg, LPCLSID pClsidNew);
WINOLEAPI OleGetAutoConvert(REFCLSID clsidOld, LPCLSID pClsidNew);
WINOLEAPI OleSetAutoConvert(REFCLSID clsidOld, REFCLSID clsidNew);
WINOLEAPI GetConvertStg(LPSTORAGE pStg);
WINOLEAPI SetConvertStg(LPSTORAGE pStg, BOOL fConvert);


WINOLEAPI OleConvertIStorageToOLESTREAMEx
    (LPSTORAGE          pstg,
                                    // Presentation data to OLESTREAM
     CLIPFORMAT         cfFormat,   //      format
     LONG               lWidth,     //      width
     LONG               lHeight,    //      height
     DWORD              dwSize,     //      size in bytes
     LPSTGMEDIUM        pmedium,    //      bits
     LPOLESTREAM        polestm);

WINOLEAPI OleConvertOLESTREAMToIStorageEx
    (LPOLESTREAM        polestm,
     LPSTORAGE          pstg,
                                    // Presentation data from OLESTREAM
     CLIPFORMAT FAR*    pcfFormat,  //      format
     LONG FAR*          plwWidth,   //      width
     LONG FAR*          plHeight,   //      height
     DWORD FAR*         pdwSize,    //      size in bytes
     LPSTGMEDIUM        pmedium);   //      bits

/****** Storage API Prototypes ********************************************/


WINOLEAPI StgCreateDocfile(const OLECHAR FAR* pwcsName,
            DWORD grfMode,
            DWORD reserved,
            IStorage FAR * FAR *ppstgOpen);

WINOLEAPI StgCreateDocfileOnILockBytes(ILockBytes FAR *plkbyt,
                    DWORD grfMode,
                    DWORD reserved,
                    IStorage FAR * FAR *ppstgOpen);

WINOLEAPI StgOpenStorage(const OLECHAR FAR* pwcsName,
              IStorage FAR *pstgPriority,
              DWORD grfMode,
              SNB snbExclude,
              DWORD reserved,
              IStorage FAR * FAR *ppstgOpen);
WINOLEAPI StgOpenStorageOnILockBytes(ILockBytes FAR *plkbyt,
                  IStorage FAR *pstgPriority,
                  DWORD grfMode,
                  SNB snbExclude,
                  DWORD reserved,
                  IStorage FAR * FAR *ppstgOpen);

WINOLEAPI StgIsStorageFile(const OLECHAR FAR* pwcsName);
WINOLEAPI StgIsStorageILockBytes(ILockBytes FAR* plkbyt);

WINOLEAPI StgSetTimes(OLECHAR const FAR* lpszName,
                   FILETIME const FAR* pctime,
                   FILETIME const FAR* patime,
                   FILETIME const FAR* pmtime);

// FROM OLESTD.H

STDAPI_(UINT)     OleStdGetUserTypeOfClass(REFCLSID rclsid,
                                           LPTSTR lpszUserType,
                                           UINT cch,
                                           HKEY hKey);

// From OleCtl.h

/////////////////////////////////////////////////////////////////////////////
//  Standard dispatch ID constants

#define DISPID_AUTOSIZE                 (-500)
#define DISPID_BACKCOLOR                (-501)
#define DISPID_BACKSTYLE                (-502)
#define DISPID_BORDERCOLOR              (-503)
#define DISPID_BORDERSTYLE              (-504)
#define DISPID_BORDERWIDTH              (-505)
#define DISPID_DRAWMODE                 (-507)
#define DISPID_DRAWSTYLE                (-508)
#define DISPID_DRAWWIDTH                (-509)
#define DISPID_FILLCOLOR                (-510)
#define DISPID_FILLSTYLE                (-511)
#define DISPID_FONT                     (-512)
#define DISPID_FORECOLOR                (-513)
#define DISPID_ENABLED                  (-514)
#define DISPID_HWND                     (-515)
#define DISPID_TABSTOP                  (-516)
#define DISPID_TEXT                     (-517)
#define DISPID_CAPTION                  (-518)
#define DISPID_BORDERVISIBLE            (-519)

#define DISPID_REFRESH                  (-550)
#define DISPID_DOCLICK                  (-551)
#define DISPID_ABOUTBOX                 (-552)

#define DISPID_CLICK                    (-600)
#define DISPID_DBLCLICK                 (-601)
#define DISPID_KEYDOWN                  (-602)
#define DISPID_KEYPRESS                 (-603)
#define DISPID_KEYUP                    (-604)
#define DISPID_MOUSEDOWN                (-605)
#define DISPID_MOUSEMOVE                (-606)
#define DISPID_MOUSEUP                  (-607)
#define DISPID_ERROREVENT               (-608)

#define DISPID_AMBIENT_BACKCOLOR        (-701)
#define DISPID_AMBIENT_DISPLAYNAME      (-702)
#define DISPID_AMBIENT_FONT             (-703)
#define DISPID_AMBIENT_FORECOLOR        (-704)
#define DISPID_AMBIENT_LOCALEID         (-705)
#define DISPID_AMBIENT_MESSAGEREFLECT   (-706)
#define DISPID_AMBIENT_SCALEUNITS       (-707)
#define DISPID_AMBIENT_TEXTALIGN        (-708)
#define DISPID_AMBIENT_USERMODE         (-709)
#define DISPID_AMBIENT_UIDEAD           (-710)
#define DISPID_AMBIENT_SHOWGRABHANDLES  (-711)
#define DISPID_AMBIENT_SHOWHATCHING     (-712)
#define DISPID_AMBIENT_DISPLAYASDEFAULT (-713)
#define DISPID_AMBIENT_SUPPORTSMNEMONICS (-714)
#define DISPID_AMBIENT_AUTOCLIP         (-715)


/////////////////////////////////////////////////////////////////////////////
// Dispatch ID constants for font and picture types

#define DISPID_FONT_NAME    0
#define DISPID_FONT_SIZE    2
#define DISPID_FONT_BOLD    3
#define DISPID_FONT_ITALIC  4
#define DISPID_FONT_UNDER   5
#define DISPID_FONT_STRIKE  6
#define DISPID_FONT_WEIGHT  7
#define DISPID_FONT_CHARSET 8

#define DISPID_PICT_HANDLE  0
#define DISPID_PICT_HPAL    2
#define DISPID_PICT_TYPE    3
#define DISPID_PICT_WIDTH   4
#define DISPID_PICT_HEIGHT  5
#define DISPID_PICT_RENDER  6



#pragma restore
#endif     // __OLE16_H__

